#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################

$iframes = 0; # 1 = iframes, 0 = frames (no iframes)

sub AdminList { # This file servers the purpose of quickly loading the admin center, with little wait and CPU
	my(%LoadAdminIndex,$core,$sub);
	if($URL{'a'} eq 'verify') { VerifyAdmin(); }
	is_admin();

	%LoadAdminIndex = (
		'temp'      => 'Admin1,Temp',
		'temp2'     => 'Admin1,Temp2',
		'iplog'     => 'Admin1,IPLog',
		'errorlog'  => 'Admin1,ErrorLog',
		'clicklog'  => 'Admin1,ClickLog',
		'remem'     => 'Admin1,Remem',
		'news'      => 'Admin1,News',
		'reserve'   => 'Admin1,Reserve',
		'encrypt'   => 'Admin1,EncryptPass',
		'sessions'  => 'Admin1,PurgeSessions',

		'sets'      => 'Admin2,Settings',
		'smiley'    => 'Admin2,Smiley',
		'delspec'   => 'Admin2,RemoveSpectators',
		'banlog'    => 'Admin2,BanLog',
		'ban'       => 'Admin2,BanUser',
		'censor'    => 'Admin2,Censor',
		'posts'     => 'Admin2,PostRecount',
		'posticons' => 'Admin2,PostIcons',

		'memgrps'       => 'Admin3,MemGrps',
		'mailing'       => 'Admin3,Mailing',
		'validate'      => 'Admin3,Validate',
		'removeelog'    => 'Admin3,RemoveELog',
		'extend'        => 'Admin3,ExtendProfile',

		'remove'    => 'Moderate,OldThreads',

		'themesman' => 'Themes,ThemeManager',
		'sourcemod' => 'SourceCodeMod,SourceMod',

		'attlog'    => 'Attach,AttachLog',

		'boards'    => 'ManageForum,ManageBoards',
		'cats'      => 'ManageForum,ManageCats',
	);

	if($URL{'r'} ne '') { $URL{'a'} = 'main'; }

	error('The modification center is an E-Blah addon that can be downloaded from E-Blah.com.') if($URL{'a'} eq 'sourcemod' && !-e("$code/SourceCodeMod.pl"));

	$adminsloaded = 1;
	if($LoadAdminIndex{$URL{'a'}}) {
		($core,$sub) = split(',',$LoadAdminIndex{$URL{'a'}});
		CoreLoad($core);
		&$sub;
	} else {
		CoreLoad('Admin1');
		AdminMain();
	}
}

sub headerA {
	if($hdone) { return; }

	CoreLoad('Admin1',1);

	if($ENV{'HTTP_ACCEPT_ENCODING'} !~ /gzip/ && $gzipen) { $gzipen = 0; } # Browser doesn't support gzip =(
	if($gzipen) { print "Content-Encoding: gzip\n"; }
	print "Content-type: text/html\n\n";

	$hdone = 1; # This is so we get no errors!

	if($templatesu eq '') { $templatesu = "/blahdocs/template"; }

	$ebout .= <<"EOT";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<link rel="stylesheet" type="text/css" href="$templatesu/$dtheme/admintemplate.css" />
<title>$title</title>
<!--[if lt IE 7.]>
<script defer type="text/javascript" src="$bdocsdir/pngfix.js"></script>
<![endif]-->
</head>
<body>
<table cellpadding="6" cellspacing="0" width="100%">
 <tr>
  <td class="titlebg" colspan="3">
   <div style="float: left"><strong><img src="$images/admin_sm.gif" class="leftimg" alt="" /> $admintxt[187]</strong></div>
   <div class="smalltext" style="float: right">E-Blah $versioncr</div>
  </td>
 </tr><tr class="win">
  <td class="menubar" style="width: 25%"><a href="$surl" onclick="target='_parent';">$Mimg{'home'}</a></td>
  <td style="width: 50%" class="center"><img src="$images/restriction.png" class="leftimg" alt="" /><img src="$images/restriction.png" class="rightimg" alt="" /> <strong>$admintxt[8]:</strong> $date_time</td>
  <td style="width: 25%" class="right menubar"><a href="$surl\v-login/p-3/" onclick="if(window.confirm('$rtxt[65]')) { parent.location = '$surl\lv-login/p-3/'; } return false;">$Mimg{'logout'}</a></td>
 </tr>
</table>
<div class="border">&nbsp;</div>
<div style="padding: 10px;">
<script type="text/javascript">
<!-- //
function clear(url,url2,explain) {
 if(!explain) { explain = "$admintxt[7]"; }
 if(window.confirm(explain)) { top.frames['adminaction'].location = url; }
  else {
   if(url2) { top.frames['adminaction'].location = url2; }
  }
}
// -->
</script>

<table cellpadding="0" cellspacing="0" width="100%">
 <tr>
 <td class="vtop" style="width: 225px">
 <table cellpadding="2" class="border" cellspacing="1" width="100%">
  <tr>
   <td class="win2 center" style="padding: 0">
    <img src="$images/eblahlogo.png" style="padding: 10px" alt="" /><br />
	<div class="win3">
     <br /><div><img src="$images/restriction.png" class="centerimg" alt="" /> <a href="$surl\v-admin/a-main/">$admintxt[187]</a></div><br />
     <div><img src="$images/site_sm.gif" class="centerimg" alt="" /> <a href="$surl">$admintxt[188]</a></div><br />
	</div>
  </td>
 </tr><tr>
  <td>
   <table cellpadding="5" cellspacing="0" class="border" width="100%" id="mm">
    <tr>
     <td class="catbg"><strong>$admintxt[219]</strong></td>
    </tr><tr>
     <td class="win smalltext">
      <strong><a href="$surl\v-admin/a-sets/">$admintxt[16]</a><br />
      <a href="$surl\v-admin/a-cats/">$admintxt[43]</a><br />
      <a href="$surl\v-admin/a-boards/">$admintxt[223]</a><br />
      <a href="$surl\v-admin/a-smiley/">$admintxt[44]</a><br />
      <a href="$surl\v-admin/a-censor/">$admintxt[46]</a><br />
      <a href="$surl\v-admin/a-posticons/">$admintxt[218]</a><br />
      <a href="$surl\v-admin/a-news/">$admintxt[49]</a>
EOT

	$ebout .= qq~<br /><a href="$surl\v-admin/a-sourcemod/">$admintxt[50]</a></strong>~ if(-e("$code/SourceCodeMod.pl"));

	$ebout .= <<"EOT";
     </td>
    </tr><tr>
     <td class="catbg"><strong>$admintxt[51]</strong></td>
    </tr><tr>
     <td class="win smalltext">
      <strong><a href="$surl\v-admin/a-themesman/">$admintxt[47]</a><br />
      <a href="$surl\v-admin/a-temp/">$admintxt[52]</a></strong>
     </td>
    </tr><tr>
     <td class="catbg"><strong>$admintxt[54]</strong></td>
    </tr><tr>
     <td class="win smalltext">
      <strong><a href="$surl\v-admin/a-memgrps/">$admintxt[55]</a><br />
      <a href="$surl\v-admin/a-mailing/">$admintxt[58]</a><br />
      <a href="$surl\v-admin/a-ban/">$admintxt[45]</a><br />
      <a href="$surl\v-admin/a-validate/">$admintxt[63]</a><br />
      <a href="$surl\v-register/">$admintxt[185]</a><br /></strong>
     </td>
    </tr><tr>
     <td class="catbg"><strong>$admintxt[59]</strong></td>
    </tr><tr>
     <td class="win smalltext">
      <strong><a href="$surl\v-admin/a-delspec/">$admintxt[61]</a><br />
      <a href="$surl\v-admin/a-reserve/">$admintxt[171]</a><br />
      <a href="javascript:clear('$surl\v-admin/a-posts/','','$admintxt[159]')">$admintxt[160]</a><br />
      <a href="$surl\v-admin/a-encrypt/">$admintxt[184]</a></strong>
     </td>
    </tr><tr>
     <td class="catbg"><strong>$admintxt[68]</strong></td>
    </tr><tr>
     <td class="win smalltext">
      <strong><a href="$surl\v-admin/a-attlog/">$admintxt[69]</a><br />
      <a href="$surl\v-admin/a-banlog/">$admintxt[70]</a><br />
      <a href="$surl\v-admin/a-clicklog/">$admintxt[71]</a><br />
      <a href="$surl\v-admin/a-errorlog/">$admintxt[72]</a><br />
      <a href="$surl\v-admin/a-iplog/">$admintxt[73]</a><br />
      <a href="$surl\v-admin/a-sessions/">$admintxt[222]</a><br />
     </td>
    </tr>
   </table>
  </td>
 </tr>
 </table>
 </td>
 <td>&nbsp;</td>
 <td class="vtop">
EOT

}

sub footerA {
	if($debug && $members{'Administrator',$username}) { # Debug, remove in finals
		if($start_debug) { $time_running = sprintf("%.4f",Time::HiRes::time() - $start_debug); }
		$gzipend = $gzipen ? 'Enabled' : 'Disabled';

		if($^O eq 'linux') {
			$uptime = `uptime`;
			($t,$la) = split("load average:",$uptime);
			($five) = split(", ",$la);
		}

		($sqlinsert,$sqlupdate,$sqlselect,$sqldelete,$stats) = SQL->stats();
		$sqltotal = $sqlinsert+$sqlupdate+$sqlselect+$sqldelete;

		$ebout .= qq~<div style="text-align: center"><br /><img src="$images/clock.png" class="centerimg" alt="" /> $time_running seconds &nbsp; <img src="$images/files.png" class="centerimg" alt="" /> $cachedqueries cached queries &nbsp; <img src="$images/files.png" class="centerimg" alt="" /> Queries: $sqlselect ($sqltotal\lti, $sqlinsert\i, $sqlupdate\lu, $sqldelete\d) &nbsp; <img src="$images/gzip.png" class="centerimg" alt="" /> $gzipend &nbsp; <img src="$images/cpu.png" class="centerimg" alt="" /> $five</div>$openedfilenames<br />$stats~;
		if($debug == 2 || $debug == 4) { sleep(5); }
	}

	$ebout .= <<"EOT";
 </td>
 </tr>
</table>
</div>
<br />
</body>
</html>
EOT
	if($gzipen) {
		if($gzipen == 2) {
			open(GZIP,"| gzip -f");
			print GZIP $ebout;
			close(GZIP);
		} else {
			require Compress::Zlib;
			binmode STDOUT;
			print Compress::Zlib::memGzip($ebout);
		}
	} else { print $ebout; }
}

sub VerifyAdmin { # Verify's user is a moderator or Administrator with Password Verification
	return(1) if($URL{'v'} eq 'memberpanel' && $URL{'a'} eq 'view');

	if($FORM{'passver'} ne '') {
		$password1 = Encrypt(Format($FORM{'passver'}));
		if($yabbconver) { $password2 = $memberid{$username}{'password'}; } else { $password2 = Encrypt($memberid{$username}{'password'}); }

		if($password1 eq $password2) {
			require Digest::MD5;
			import Digest::MD5 qw(md5_hex);
			$FORM{'verificate'} = md5_hex(Format($FORM{'verificate'}));
			if($memberid{$username}{'adminverify'} ne '' && $memberid{$username}{'adminverify'} ne $FORM{'verificate'}) {}
				else {
					$session->param('admin_login','1');
					$session->expire('admin_login',$FORM{'length'}); # Let's not kill the human. One password verify per three days ...
					if($memberid{$username}{'adminverify'} ne '') {
						$session->param('adminverify',$FORM{'verificate'});
						$session->expire('adminverify',$FORM{'length'});
					} else { $session->clear(["adminverify"]); }
					$session->flush();
					redirect("$surl$FORM{'location'}");
				}
		}
	}
	if($session->param('admin_login') && $session->param('adminverify') eq $memberid{$username}{'adminverify'}) { return(1); }
	if($FORM{'location'} ne '') { $ENV{'QUERY_STRING'} = $FORM{'location'}; }

	$title = $rtxt[71];
	header();
	$ebout .= <<"EOT";
<form action="$surl\lv-admin/a-verify/" method="post">
<table cellpadding="6" cellspacing="1" class="border" width="400">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win"><img src="$images/admincenter/sessions.png" class="centerimg" /> $rtxt[72]</td>
 </tr><tr>
  <td class="catbg smalltext"><strong>$rtxt[73]</strong></td>
 </tr><tr>
  <td class="win2 center"><input type="password" name="passver" style="width: 360px" /></td>
 </tr>
EOT
	if($memberid{$username}{'adminverify'}) {
		$ebout .= <<"EOT";
 <tr>
  <td class="catbg smalltext"><strong>$rtxt[79]</strong></td>
 </tr><tr>
  <td class="win2 center"><input type="password" name="verificate" style="width: 360px" /></td>
 </tr>
EOT
	}
	$ebout .= <<"EOT";
 <tr>
  <td class="catbg smalltext"><strong>$rtxt[74]</strong></td>
 </tr><tr>
  <td class="win2 center"><select name="length" style="width: 360px;"><option value="6h">6 $rtxt[75]</option><option value="24h">24 $rtxt[75]</option><option value="72h" selected="selected">3 $rtxt[76]</option><option value="1w">1 $rtxt[77]</option><option value="2w">2 $rtxt[77]</option><option value="1M">1 $rtxt[78]</option></select></td>
 </tr><tr>
  <td class="center win3"><input type="hidden" name="location" value="$ENV{'QUERY_STRING'}" /><input type="submit" value="$rtxt[71]" /></td>
 </tr>
</table>
</form>
EOT
	footer();
	exit;
}
1;