#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################

CoreLoad('Moderate',1);

sub Moderate {
	$cache = Cache->new();
	$cache->delete('boards');

	foreach(split(",",$newsboard)) { $newsboards{$_} = 1; }

	$ipon  = 1 if($ismod);
	$ismod = 1 if($modon);

	if($URL{'a'} eq 'delnum') { Delnum(); }
	if($URL{'a'} eq 'ban') { IPBan(); }
	if($URL{'a'} eq 'ban2') { IPBan2(); }
	if($URL{'a'} eq 'sticky' && ($ston || $ismod)) { $ismod = 1; }
	elsif($URL{'a'} eq 'sticky' && !$ston) { $ismod = 0; }
	is_mod();
	if($URL{'a'} eq 'delthread') { DelThread(); }
	if($URL{'a'} eq 'move') { Move(); }
	if($URL{'a'} eq 'move2') { Move2(); }
	if($URL{'a'} eq 'sticky') { Sticky(); }
	if($URL{'a'} eq 'lock') { Lock(); }
	if($URL{'a'} eq 'split') { Split(); }
	if($URL{'a'} eq 'merge') { Merge(); }
	if($URL{'a'} eq 'mindex') { QMIndex(); }
	if($URL{'a'} eq 'modlog') { ModLog(); }
	CoreLoad('MessageDisplay'); MessageDisplay(); # No mod needed
}

sub QMIndex {
	my($i);

	$noredirh = 1;
	for($i = 0; $i <= $maxdis; $i++) {
		if($FORM{$i} eq '') { next; }
		$URL{'m'} = $FORM{$i};
		if($FORM{'opt1'}) { Sticky(); $oR = 1; }
		if($FORM{'opt2'}) { Lock(); $oR = 1; }
		if($FORM{'opt4'}) { Move2(); $oR = 1; }
		if($FORM{'opt3'} && !$oR) { DelThread(); } # Only if others were not run!
	}

	# Rebuild the news ...
	Shownews('1','html');
	Shownews('1','xml');

	redirect("$surl\lb-$URL{'b'}/");
}

sub Delnum {
	my($id,$sqlmid,$messageid,$topicid,$replies,$sqltid);

	$sqlstate = SQL->new('posts');
	$sqlstate->where('id');
	$sqlstate->columns('boardid','threadid','tuser','posttime','attachment');
	%thread = $sqlstate->select($URL{'n'});
	$messageid = $sqlstate->{_varval};

	$sqlstate = SQL->new('topics');
	$sqlstate->where('id');
	$sqlstate->columns('replies','type');
	%topic = $sqlstate->select($thread{$messageid}{'threadid'});
	$topicid = $sqlstate->{_varval};

	error($moderate[2]) if($topic{$topicid}{'type'});
	error($moderate[72]) if($modifytime && (!$members{'Administrator',$username} && !$ismod && !$modifyon) && $thread{$messageid}{'posttime'}+($modifytime*3600) < time);
	error($moderate[4]) if((!$members{'Administrator',$username} && !$ismod && !$modifyon) && $thread{$messageid}{'tuser'} ne $username);
	error($moderate[4]) if($thread{$messageid}{'threadid'} eq '');

	RemoveAttachments($thread{$messageid}{'attachment'});

	if($topic{$topicid}{'replies'} == 0) {
		DeleteThreadFinal($thread{$messageid}{'threadid'},$thread{$messageid}{'boardid'});
		redirect("$surl\lb-$thread{$messageid}{'boardid'}/");
	}

	# Delete the message, update replies
	$sqlstate = SQL->new('posts');
	$sqlstate->where('id');
	$sqlstate->delete($URL{'n'});

	$sqlstate = SQL->new('posts');
	$sqlstate->where('threadid');
	$sqlstate->order('posttime|DESC');
	$sqlstate->columns('tuser','posttime','threadid');
	%threadn = $sqlstate->select($thread{$messageid}{'threadid'});
	$sqlmid = $sqlstate->{_varval};

	$sqlstate->columns('id');
	$replies = $sqlstate->count($thread{$messageid}{'threadid'})-1;

	$sqlstate->where('boardid');

	$sqlstate = SQL->new('topics');
	$sqlstate->where('id');
	$sqlstate->set('replies','lasttime','lastuser');
	$sqlstate->update($replies,$threadn{$sqlmid}{'posttime'},$threadn{$sqlmid}{'tuser'},$thread{$messageid}{'threadid'});

	$sqlstate = SQL->new('topics');
	$sqlstate->where('boardid');
	$sqlstate->columns('id');

	$sqlstate->columns('replies','icon','lastuser','subject','lasttime');
	$sqlstate->order('id|DESC');
	%topic = $sqlstate->select($thread{$messageid}{'boardid'});
	$sqltid = $sqlstate->{_varval};

	$sqlstate = SQL->new('boards');
	$sqlstate->set('lastpost','lastsubject','lastuser','lasticon','lastmid','posts|-1');
	$sqlstate->where('id');
	$sqlstate->update($topic{$sqltid}{'lasttime'},$topic{$sqltid}{'subject'},$topic{$sqltid}{'lastuser'},$topic{$sqltid}{'icon'},$threadn{$sqlmid}{'threadid'},$thread{$messageid}{'boardid'});

	MLogging($URL{'m'},8,$username,time,"$URL{'n'}/$pdu",$URL{'b'});

	if($newsboards{$URL{'b'}}) {
		Shownews('1','html');
		Shownews('1','xml');
	}

	redirect("$surl\lm-$URL{'m'}/");
}

sub RemoveAttachments {
	foreach $deletefile (split(/\//,$_[0])) {
		unlink("$uploaddir/$deletefile","$uploaddir/thumbnails/$deletefile","$prefs/Hits/$deletefile.txt");
	}
}

sub DelThread {
	my($boardid);

	$sqlsearch = SQL->new('posts','id');
	$sqlsearch->where('threadid');
	$sqlsearch->columns('attachment','id');
	%thread = $sqlsearch->select($URL{'m'});

	foreach($sqlsearch->col_array()) {
		RemoveAttachments($thread{$_}{'attachment'});
	}

	$sqlsearch = SQL->new('topics');
	$sqlsearch->where('id');
	$sqlsearch->columns('boardid');
	%thread = $sqlsearch->select($URL{'m'});
	$sqlmid = $sqlsearch->{_varval};
	$boardid = $thread{$sqlmid}{'boardid'};

	DeleteThreadFinal($URL{'m'},$boardid);

	if($newsboards{$URL{'b'}}) {
		Shownews('1','html');
		Shownews('1','xml');
	}

	if(!$noredirh) { redirect("$surl\lb-$boardid/"); }
		else { return(); }
}

sub DeleteThreadFinal {
	my($messageid,$board) = @_;
	my($sqlmid,$sqltid,$posts,$topics);

	# Delete the thread and posts ... all selects have already been done in DeleteThread/Delnum!
	$sql = SQL->new('topics','id');
	$sql->where('id');
	$sql->columns('replies','id');
	%replies = $sql->select($messageid);
	$sql->delete($messageid);

	$sql = SQL->new('posts');
	$sql->where('threadid');
	#$sql->delete($messageid);

	# Remove Poll data ..
	$sql = SQL->new('polllog');
	$sql->where('threadid');
	$sql->delete($messageid);
	$sql = SQL->new('polloptions');
	$sql->where('threadid');
	$sql->delete($messageid);

	# Find what the new thread is for the board index
	++$replies{$messageid}{'replies'};
	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|-$replies{$messageid}{'replies'}",'threads|-1');
	$sql->update($board);

	GetLastPostInfo($board);

	MLogging($URL{'m'},6,$username,time,'',$board);
}

sub GetLastPostInfo {
	my($boardid) = @_;
	my(%topic,$sqltid,$sql);

	$sql = SQL->new('topics');
	$sql->where('boardid');
	$sql->columns('replies','icon','lastuser','subject','lasttime','id');
	$sql->order('lasttime|DESC');
	%topic = $sql->select($boardid);
	$sqltid = $sql->{_varval};

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set('lastpost','lastsubject','lastuser','lasticon','lastmid');
	$sql->update($topic{$sqltid}{'lasttime'},$topic{$sqltid}{'subject'},$topic{$sqltid}{'lastuser'},$topic{$sqltid}{'icon'},$topic{$sqltid}{'id'},$boardid);
}

sub Lock {
	my($sqlmid,$locked);

	$sql = SQL->new('topics');
	$sql->where('id');
	$sql->columns('type','boardid');
	%thread = $sql->select($URL{'m'});
	$sqlmid = $sql->{_varval};

	$locked = $thread{$sqlmid}{'type'} ? 0 : 1;

	$sql->set('type');
	$sql->update($locked,$URL{'m'});

	MLogging($URL{'m'},3,$username,time,$lock,$thread{$URL{'m'}});

	$url = $locked ? "$surl\lb-$thread{$sqlmid}{'boardid'}/" : "$surl\lm-$URL{'m'}/";
	if(!$noredirh) { redirect(); }
}

sub Sticky {
	my($noadd,$added,$id);
	if($access && !$members{'Administrator',$username}) { error($gtxt{'error'}); }

	$sql = SQL->new('topics');
	$sql->where('id');
	$sql->columns('sticky');
	%thread = $sql->select($URL{'m'});
	$sqlmid = $sql->{_varval};

	$stick = $thread{$sqlmid}{'sticky'} ? 0 : 1;

	$sql->set('sticky');
	$sql->update($stick,$URL{'m'});

	MLogging($URL{'m'},2,$username,time,$added,$thread{$URL{'m'}});

	if(!$noredirh && !$unstickstick) { redirect("$surl\lb-$URL{'b'}/"); }
}

sub Move {
	$temp = $grood = '';
	SubCatsList(0,'',1);
	$ops = $temp;
	error($moderate[69]) if(!$grood);

	if($showmove) {
		$totalmove = <<"EOT";
<tr>
 <td class="vtop right"><input type="checkbox" name="showmove2" value="1" checked="checked" /></td>
 <td><strong>$moderate[70]</strong><div class="smalltext">$moderate[71]</div></td>
</tr>
EOT
	}

	$title = $moderate[18];
	header();
	$ebout .= <<"EOT";
<form action="$surl\lv-mod/b-$URL{'b'}/a-move2/m-$URL{'m'}/" method="post">
<table class="border" cellpadding="5" cellspacing="1" width="500">
 <tr>
  <td class="titlebg"><strong>$title</strong></td>
 </tr><tr>
  <td class="win2 smalltext">$moderate[19]</td>
 </tr><tr>
  <td class="win">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td style="width: 40%" class="right"><strong>$moderate[20]:</strong></td>
     <td style="width: 60%"><select name="b">$ops</select></td>
    </tr>$totalmove
   </table>
  </td>
 </tr><tr>
  <td class="win2 center"><input type="submit" name="move" value="&nbsp;$moderate[21] " /></td>
 </tr>
</table>
</form>
EOT
	footer();
	exit;
}

sub Move2 {
	my($totalposts,$movingid);
	$movingid = $URL{'m'};

	error($gtxt{'bfield'}) if($boards{$FORM{'b'}}{'name'} eq '' || $URL{'b'} eq $FORM{'b'});

	$sql = SQL->new('topics','id');
	$sql->where('id');
	$sql->columns('id','replies','subject');

	%replies = $sql->select($movingid);
	error($gtxt{'bfield'}) if($replies{$movingid}{'replies'} eq '');

	$sql->set('boardid');
	$sql->update($FORM{'b'},$movingid);

	$sql = SQL->new('posts');
	$sql->where('threadid');
	$sql->set('boardid');
	$sql->update($FORM{'b'},$movingid);

	++$replies{$movingid}{'replies'};
	$posts = $replies{$movingid}{'replies'};
	$threads = 1;

	if($showmove) {
		$showmove = 0 if($FORM{'showmove2'} != 1 && !$noredirh);
		$thread = SQL->new('topics');
		$thread->into('boardid','creationtime','subject','startuser','replies','lasttime','lastuser','moveid');
		$thread->insert($URL{'b'},time,$replies{$movingid}{'subject'},$username,0,time,$username,$movingid);
		$posts -= 1;
		$threads -= 1;
	}

	GetLastPostInfo($URL{'b'});

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|-$posts","threads|-$threads");
	$sql->update($URL{'b'});

	GetLastPostInfo($FORM{'b'});

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|+$replies{$movingid}{'replies'}",'threads|+1');
	$sql->update($FORM{'b'});

	MLogging($movingid,1,$username,time,$FORM{'b'},$FORM{'b'});

	if(!$noredirh) { redirect("$surl\lm-$movingid/"); }
}

sub IPBan {
	IPBanOk();

	$thread = SQL->new('banlist');
	$thread->into('user','dateadded','group');
	$thread->insert($URL{'ip'},time,'Message IP Ban');

	redirect("$surl\lm-$URL{'m'}/");
}

sub IPBanOk {
	if($URL{'ip'} eq $ENV{'REMOTE_ADDR'}) { error($moderate[36]); }
	if($ipon != 1 && !$members{'Administrator',$username}) { error($gtxt{'error'}); }
	if($URL{'ip'} !~ /[1-9.]/ || $URL{'ip'} =~ /[A-Za-z]/) { error($gtxt{'bfield'}); }
}

sub OldThreads {
	is_admin();
	CoreLoad('AdminList');
	if($URL{'p'}) { OldThreads2(); }

	$title = $moderate[41];
	headerA();
	$ebout .= <<"EOT";
<form action="$surl\lv-admin/a-remove/p-1/" method="post" enctype="multipart/form-data" onsubmit="if(!window.confirm('$moderate[104]')) { return false; }">
<table class="border" cellpadding="6" cellspacing="1" width="500">
 <tr>
  <td class="titlebg"><strong><img src="$images/brd_main.gif" alt="" /> $title</strong></td>
 </tr><tr>
  <td class="win smalltext">$moderate[37]</td>
 </tr><tr>
  <td class="win2"><strong>$moderate[38] <input type="text" name="days" value="30" size="4" /> $moderate[39].</strong></td>
 </tr><tr>
  <td class="catbg smalltext center"><strong>$moderate[40]</strong></td>
 </tr><tr>
  <td class="win center"><select name="boards" size="10" style="width: 300px;" multiple="multiple">
EOT
	$cats = '';

	foreach(@catbase) {
		($t,$boardid,$memgrps,$t,$t,$subcats) = split(/\|/,$_);
		$catbase{$boardid} = $_;
		foreach(split(/\//,$subcats)) { $noshow{$_} = 1; }

		$cats .= "$boardid/";
	}

	foreach(@boardbase) {
		($id,$t,$t,$t,$t,$t,$t,$passed,$t,$t,$boardgood,$t,$t,$redir) = split("/",$_);
		$board{$id} = $_;
		$scat{$id} = ' selected="selected"';
	}

	$temp = '';
	SubCatsList($cats,1);
	$ebout .= $temp;

	$ebout .= <<"EOT";
  </select></td>
 </tr><tr>
  <td class="win2 center"><input type="submit" value=" $moderate[41] " /></td>
 </tr>
</table>
</form>
EOT
	footerA();
	exit;
}

sub OldThreads2 {
	# Lock the forum ...
	fopen(FILE,">$root/Maintance.lock");
	print FILE "\$maintance = 1;\n\$maintancer = qq~$moderate[51]~;\n1;";
	fclose(FILE);

	$threadold = time-($FORM{'days'}*86400);

	$counter = 0;
	@delbds = split(",",$FORM{'boards'});
	foreach(@delbds) { $temp{$_} = 1; }

	fopen(FILE,"$boards/Stick.txt");
	@sticky = <FILE>;
	fclose(FILE);
	chomp @sticky;
	foreach(@sticky) {
		($bdat,$tdat) = split(/\|/,$_);
		if(!$temp{$bdat}) { $other = "$_\n"; next; }
		$stick{$tdat} = $bdat;
	}

	fopen(MODLOG,">>$prefs/Moderator.log");
	foreach $open (@delbds) {
		unlink("$boards/$open.msg.bak","$boards/$open.msg.temp");
		rename("$boards/$open.msg","$boards/$open.msg.bak");
		fopen(FILE,"$boards/$open.msg.bak") || error("$moderate[1]: $open.msg.bak");
		@messdata = <FILE>;
		fclose(FILE);
		chomp @messdata;
		fopen(FILE,">$boards/$open.msg.temp");
		foreach(@messdata) {
			($id,$mtitle) = split(/\|/,$_);
			if($id > $threadold || $stick{$id}) { # If thread is old, or is stuck, leave it ...
				print FILE "$_\n";
				next;
			}

			$keep = 0;

			fopen(MESS,"$messages/$id.txt");
			@mread = <MESS>;
			fclose(MESS);
			chomp @mread;
			foreach $read (@mread) {
				($t,$t,$t,$t,$oldtime,$t,$t,$t,$afile) = split(/\|/,$read);
				if($afile) {
					foreach $deletefile (split(/\//,$afile)) { unlink("$uploaddir/$deletefile","$uploaddir/thumbnails/$deletefile","$prefs/Hits/$deletefile.txt"); }
				}
				if($oldtime > $threadold) { # Thread is old, but has been active within the past x days
					print FILE "$_\n";
					$keep = 1;
					last;
				}
			}
			if(!$keep) {
				GetMessageDatabase($id,'',2);
				print MODLOG "7|$username|".time."|$mtitle|$ENV{'REMOTE_ADDR'}|$id|$open|$mtitle\n";
				unlink("$messages/$id.txt","$messages/$id.rate","$messages/$id.txt.temp","$messages/$id.view","$messages/$id.polled","$messages/Mail/$id.mail","$messages/$id.poll");
				++$counter;
			}
		}
		fclose(FILE);
		unlink("$boards/$open.msg.bak");
		rename("$boards/$open.msg.temp","$boards/$open.msg");
	}
	fclose(MODLOG);

	CoreLoad('Admin1');
	Repop();

	$title = $moderate[62];
	headerA();
	$ebout .= <<"EOT";
<table class="border" cellpadding="4" cellspacing="1" width="500">
 <tr>
  <td class="titlebg"><strong><img src="$images/brd_main.gif" alt="" /> $title</strong></td>
 </tr><tr>
  <td class="win smalltext"><strong>$moderate[45]: $counter<br />$moderate[46]: $attcnt</strong></td>
 </tr><tr>
  <td class="win2"><strong><a href="javascript:history.back(-2)">&#171; $gtxt{'26'}</a></strong></td>
 </tr>
</table>
EOT
	footerA();
	exit;
}

sub Split {
	$messid = $URL{'m'};

	$sql = SQL->new('topics','id');
	$sql->where('id');
	%message = $sql->select($URL{'m'});
	error("$moderate[1]: $messageid") if($message{$URL{'m'}}{'id'} eq '');

	$sql = SQL->new('posts','id');
	$sql->where('threadid');
	$sql->limit();
	%messages = $sql->select($URL{'m'});
	@message = $sql->col_array();

	if(@message == 1) { error($moderate[53]); }
	if($URL{'p'}) { Split2(); }

	$temp = '';
	SubCatsList(0);
	$ops = $temp;

	$title = $moderate[54];
	header();
	$ebout .= <<"EOT";
<form action="$scripturl/v-mod/a-split/m-$URL{'m'}/p-1/" method="post">
<table cellpadding="4" cellspacing="1" class="border" width="750">
 <tr>
  <td class="titlebg"><strong>$title</strong></td>
 </tr><tr>
  <td class="win smalltext">$moderate[55]</td>
 </tr><tr>
  <td class="win2">
   <table cellpadding="4" cellspacing="0" width="100%">
    <tr>
     <td class="right" style="width: 45%"><strong>$moderate[56]:</strong></td>
     <td style="width: 55%">$message{$URL{'m'}}{'subject'}</td>
    </tr><tr>
     <td colspan="2"><hr /></td>
    </tr><tr>
     <td class="right" style="width: 45%"><strong>$moderate[57]:</strong></td>
     <td style="width: 55%"><input type="text" name="title" size="30" maxlength="50" /></td>
    </tr><tr>
     <td class="right" style="width: 45%"><strong>$moderate[58]:</strong></td>
     <td style="width: 55%"><select name="board">$ops</select></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
<br />
<table class="border" cellpadding="4" cellspacing="1" width="750">
 <tr>
  <td class="center vtop catbg smalltext"><strong>$moderate[59]</strong></td>
  <td class="catbg smalltext center"><strong>$moderate[60]</strong></td>
 </tr>
EOT
	@bgcolors = ('win','win2');
	$count = 0;

	foreach(@message) {
		push(@massuser,$messages{$_}{'tuser'});
	}
	GetMassUsers(@massuser);

	foreach(@message) {
		$bgcolor = $bgcolors[$count % 2];

		GetMemberID($messages{$_}{'tuser'});
		if($memberid{$messages{$_}{'tuser'}}{'sn'} eq '') { $postedby = $messages{$_}{'tuser'}; }
			else { $postedby = $userurl{$messages{$_}{'tuser'}}; }
		$datepost = get_date($messages{$_}{'posttime'});

		if(length($messages{$_}{'message'}) > 200) {
			$messages{$_}{'message'} =~ s~\[table\](.*?)\[\/table\]~$var{'88'}~sgi;
			$message = substr($messages{$_}{'message'},0,200);
			$message = BC($message);
			MakeSmall();
			$message .= " ...";
		} else { $message = BC($messages{$_}{'message'}); }

		if($count > 0) { $split = qq~<input type="checkbox" name="split_$_" value="1" />~; }

		$ebout .= <<"EOT";
 <tr>
  <td class="center $bgcolor">$split</td>
  <td class="$bgcolor">
  <table cellpadding="1" width="100%">
   <tr>
    <td class="smalltext"><strong>$gtxt{'19'}:</strong> $postedby</td>
    <td class="right smalltext"><strong>$gtxt{'21'}:</strong> $datepost</td>
   </tr><tr>
    <td colspan="2"><hr />$message</td>
   </tr>
  </table></td>
 </tr>
EOT
		++$count;
	}
	$bgcolor = $bgcolors[$count % 2];
	$ebout .= <<"EOT";
 <tr>
  <td class="$bgcolor center" colspan="2"><input type="submit" value=" $moderate[54] " /></td>
 </tr>
</table>
</form>
EOT
	footer();
	exit;
}

sub Split2 {
	$sub = Format($FORM{'title'});
	if($sub eq '') { error($gtxt{'bfield'}); }
	if(length($sub) > 50) { error($gtxt{'bfield'}); }
	if($boards{$FORM{'board'}}{'name'} eq '') { error($gtxt{'bfield'}); }

	$sql = SQL->new('posts','id');
	$sql->where('threadid');
	$sql->columns('id','tuser','posttime');
	$sql->limit();
	$sql->order('posttime|ASC');
	%messages = $sql->select($URL{'m'});
	@ids = $sql->col_array();

	$oldreplies = -1;
	$newreplies = -1;

	foreach(@ids) {
		if($FORM{"split_$_"} ne '') {
			$newfirstpost = $messages{$_}{'tuser'} if($newlastpost eq '');
			$newfirsttime = $messages{$_}{'posttime'} if($newlastpost eq '');
			$newlastpost = $messages{$_}{'tuser'};
			$newlasttime = $messages{$_}{'posttime'};
			++$newreplies;
			next;
		}
		$oldfirstpost = $messages{$_}{'tuser'} if($oldlastpost eq '');
		$oldfirsttime = $messages{$_}{'posttime'} if($oldlastpost eq '');
		$oldlastpost = $messages{$_}{'tuser'};
		$oldlasttime = $messages{$_}{'posttime'};
		++$oldreplies;
	}

	error($gtxt{'bfield'}) if($oldreplies == -1 || $newreplies == -1);

	$sql = SQL->new('topics');
	$sql->where('id');
	$sql->set('creationtime','startuser','replies','lasttime','lastuser');
	$sql->update($oldfirsttime,$oldfirstpost,$oldreplies,$oldlasttime,$oldlastpost,$URL{'m'});

	$sql = SQL->new('topics');
	$sql->into('boardid','creationtime','subject','startuser','replies','lasttime','lastuser');
	$threadid = $sql->insert($FORM{'board'},$newfirsttime,$sub,$newfirstpost,$newreplies,$newlasttime,$newlastpost);

	foreach(@ids) {
		if($FORM{"split_$_"} ne '') {
			$change = SQL->new('posts');
			$change->where('id');
			$change->set('threadid','boardid');
			$change->update($threadid,$FORM{'board'},$_);
		}
	}

	++$newreplies;

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|-$newreplies");
	$sql->update($URL{'b'});

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|+$newreplies",'threads|+1');
	$sql->update($FORM{'board'});

	GetLastPostInfo($URL{'b'});
	GetLastPostInfo($FORM{'board'});

	MLogging($messageid,4,$username,time,$sub,$FORM{'board'});

	redirect("$surl\lm-$threadid/");
}

sub Merge {
	if($FORM{'topic'} =~ s/http:\/\///gsi) {
		@url = split(/\,|\/|\?/,$FORM{'topic'});
		foreach (@url) {
			($action,$actiondo) = split("-",$_);
			if($action eq 'm') { $getfrom = $actiondo; }
		}
	} else { $getfrom = $FORM{'topic'}; }

	$sql = SQL->new('topics','id');
	$sql->where('id');
	$sql->columns('id','subject','boardid');
	%message = $sql->select($URL{'m'});

	error("$moderate[1]: $urlthread") if($message{$URL{'m'}}{'id'} eq '');
	Merge2() if($URL{'p'});

	$title = $moderate[67];
	header();
	$ebout .= <<"EOT";
<form action="$scripturl\lv-mod/a-merge/m-$URL{'m'}/p-1/" method="post">
<table cellpadding="4" cellspacing="1" class="border" width="700">
 <tr>
  <td class="titlebg"><strong>$title</strong></td>
 </tr><tr>
  <td class="win smalltext">$moderate[63]</td>
 </tr><tr>
  <td class="win2">
   <table width="100%" cellpadding="4" cellspacing="0">
    <tr>
     <td style="width: 40%" class="right"><strong>$moderate[64]:</strong></td>
     <td style="width: 60%" class="vtop"><input type="text" name="subject" value="$message{$URL{'m'}}{'subject'}" maxlength="50" size="40" /></td>
    </tr><tr>
     <td style="width: 40%" class="right"><strong>$moderate[65]:</strong><div class="smalltext">$moderate[66]</div></td>
     <td style="width: 60%" class="vtop"><input type="text" name="topic" size="50" /></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win center"><input type="submit" value="$moderate[67]" /></td>
 </tr>
</table>
</form>
EOT
	footer();
	exit
}

sub Merge2 {
	$sql = SQL->new('topics','id');
	$sql->where('id');
	%oldmessage = $sql->select($getfrom);

	$subject = Format($FORM{'subject'});
	error($gtxt{'bfield'}) if(length($subject) > 50);
	error($gtxt{'bfield'}) if($subject eq ' ' || $subject eq '&nbsp;' || $subject eq '');
	error("$moderate[1]: $getfrom") if($oldmessage{$getfrom}{'id'} eq '');
	error($moderate[68]) if($getfrom eq $urlthread);

	# Nuke the old poll data
	$sql = SQL->new('polllog');
	$sql->where('threadid');
	$sql->delete($getfrom);
	$sql = SQL->new('polloptions');
	$sql->where('threadid');
	$sql->delete($getfrom);

	$sql = SQL->new('posts');
	$sql->where('threadid');
	$sql->set('boardid','threadid');
	$sql->update($message{$URL{'m'}}{'boardid'},$URL{'m'},$getfrom);

	$sql = SQL->new('topics');
	$sql->where('id');
	$sql->delete($getfrom);

	$replies = $oldmessage{$getfrom}{'replies'}+1;

	$sql = SQL->new('posts','id');
	$sql->where('threadid');
	$sql->columns('id','tuser','posttime');
	$sql->limit();
	$sql->order('posttime|ASC');
	%messages = $sql->select($URL{'m'});
	@ids = $sql->col_array();
	$firstpost = $firsttime = '';
	foreach(@ids) {
		$firstpost = $messages{$_}{'tuser'} if($firstpost eq '');
		$firsttime = $messages{$_}{'posttime'} if($firsttime eq '');
		$lastpost = $messages{$_}{'tuser'};
		$lasttime = $messages{$_}{'posttime'};
	}

	$sql = SQL->new('topics');
	$sql->where('id');
	$sql->set('startuser','lasttime','lastuser','creationtime','subject',"replies|+$replies");
	$sql->update($firstpost,$lasttime,$lastpost,$firsttime,$subject,$URL{'m'});

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|-$replies",'threads|-1');
	$sql->update($oldmessage{$getfrom}{'boardid'});

	$sql = SQL->new('boards');
	$sql->where('id');
	$sql->set("posts|+$replies");
	$sql->update($message{$URL{'m'}}{'boardid'});

	GetLastPostInfo($message{$URL{'m'}}{'boardid'});
	GetLastPostInfo($oldmessage{$getfrom}{'boardid'});

	MLogging($starttime,5,$username,time,$tsub,$URL{'b'});

	redirect("$surl\lm-$URL{'m'}/");
}

sub ModLog {
	is_admin();

	$title = $moderate[73];
	header();

	$FORM{'searchby'} = $URL{'s'} if(!$FORM{'searchby'});
	$FORM{'value'} =~ s/\+/ /gsi;	
	$FORM{'value'} = $URL{'value'} if(!$FORM{'value'});

	$ebout .= <<"EOT";
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg" colspan="6"><strong>$title</strong></td>
 </tr>
   <tr>
    <td class="catbg" style="width: 120px"><strong>$moderate[74]</strong></td>
    <td class="catbg center" style="width: 175px"><strong>$moderate[75]</strong></td>
    <td class="catbg" style="width: 150px"><strong>$moderate[87]</strong></td>
    <td class="catbg" style="width: 170px"><strong>$moderate[86]</strong></td>
    <td class="catbg" style="width: 175px"><strong>$moderate[76]</strong></td>
    <td class="catbg center" style="width: 100px"><strong>$gtxt{'18'}</strong></td>
   </tr>
EOT
	fopen(FILE,"$prefs/Moderator.log");
	@modlog = <FILE>;
	fclose(FILE);
	chomp @modlog;

	$nolog = 1;

	$counter = $counter2 = 0;
	$npp = 25;
	foreach(reverse @modlog) {
		($id,$usr,$tm,$ext,$ipaddy,$mid,$board,$huh) = split(/\|/,$_);

		if(!$sbuser{$usr}) { push(@usrlog,$usr); $sbuser{$usr} = 1; }
			else { ++$sbuser{$usr}; }

		if(!$sbtask{$id}) { push(@tasklogs,$id); $sbtask{$id} = 1; }
			else { ++$sbtask{$id}; }

		($tb,$ttitle) = split(/\|/,$thread{$mid});

		if($URL{'u'} ne '' && $usr ne $URL{'u'}) { next; }
		elsif($URL{'m'} ne '' && $mid ne $URL{'m'}) { next; }
		elsif($URL{'t'} ne '' && $id ne $URL{'t'}) { next; }
		elsif($FORM{'searchby'} == 1 && $mid ne $FORM{'value'}) { next; }
		elsif($FORM{'searchby'} == 2 && $ttitle !~ /\Q$FORM{'value'}\E/sig && $huh !~ /\Q$FORM{'value'}\E/sig) { next; }
		elsif($FORM{'searchby'} == 3 && $board ne $FORM{'value'}) { next; }
		elsif($FORM{'searchby'} == 4 && $ipaddy !~ /\Q$FORM{'value'}/i) { next; }

		++$totallinks;
		if(($totallinks > $URL{'l'} && $counter2 < $npp)) { ++$counter2; } else { next; }

		$nolog = 0;

		if($id == 1) {
			if($boards{$ext} eq '') { $boards = $gtxt{1}; }
				else { $boards = qq~<a href="$surl\lb-$ext/">$boards{$ext}</a>~; }
			$function = "$moderate[77]: $boards";
		}
		elsif($id == 2) { $function = $ext ? $moderate[78] : $moderate[79]; }
		elsif($id == 3) { $function = $ext ? $moderate[80] : $moderate[81]; }
		elsif($id == 4) { $function = "$moderate[82] $ext"; }
		elsif($id == 5) { $function = "$moderate[83] $ext"; }
		elsif($id == 6) { $function = "$moderate[99]: $ext"; }
		elsif($id == 7) { $function = "$moderate[100]: $ext"; }
		elsif($id == 8) {
			($number,$pus) = split(/\//,$ext);
			GetMemberID($pus);
			$pus = $memberid{$pus}{'sn'} ? $userurl{$pus} : $pus;
			$function = "$gtxt{'37'} $number, $moderate[101] $pus $moderate[102]";
		} elsif($id == 9) { $function = $moderate[105]; }
			else { $function = ''; }

		$datetime = get_date($tm);
		GetMemberID($usr);
		$usr = $memberid{$usr}{'sn'} ? $userurl{$usr} : $usr;

		if($tb) { $dew = qq~<a href="$surl\lm-$mid/b-$tb/">$ttitle</a>~; }
		elsif($huh) { $dew = $huh; } else { $dew = ''; }

		if($id == 9 && $board ne '') { $board = $deletelocation[$board-1]; }
		elsif($boards{$board} eq '') { $board = $gtxt{1}; }
			else { $board = qq~<a href="$surl\lb-$board/">$boards{$board}</a>~; }

		$ebout .= <<"EOT";
<tr>
 <td class="win smalltext">$usr</td>
 <td class="center win2 smalltext">$datetime</td>
 <td class="win smalltext">$board</td>
 <td class="win2 smalltext">$dew<br />ID: $mid</td>
 <td class="win smalltext">$function</td>
 <td class="win2 smalltext center">$ipaddy</td>
</tr>
EOT
	}
	if($nolog) { $ebout .= qq~<tr><td colspan="6" class="win center"><br /><strong>$moderate[84]</strong><br /><br /></td></tr>~; }
		else {
			$counter = 1;
			$start = $URL{'l'};
			$mresults = $totallinks || 1;
			if($mresults < $npp) { $start = 0; }
			$tstart = $start || 0;

			# How many page links?
			$smax = $totalpp*20;
			$startdot = ($totalpp*2)/5;

			# Create the main link ...
			$FORM{'value'} =~ s/ /\+/gsi;
			$link = "$surl\lv-mod/a-modlog/m-$URL{'m'}/u-$URL{'u'}/t-$URL{'t'}/s-$FORM{'searchby'}/value-$FORM{'value'}/l";

			if($tstart > $mresults) { $tstart = $mresults; }
			$tstart = (int($tstart/$npp)*$npp);
			if($tstart > 0) { $bk = ($tstart-$npp); $pagelinks = qq~<a href="$link-$bk/">&#171;</a> ~; }
			if($mresults > ($smax/2) && $tstart > $npp*($startdot+1) && $mresults > $smax) {
				$sbk = $tstart-$smax; $sbk = 0 if($sbk < 0); $pagelinks .= qq~<a href="$link-$sbk/">...</a> ~;
			}
			for($i = 0; $i < $mresults; $i += $npp) {
				if($i < $bk-($npp*$startdot) && $mresults > $smax) { ++$counter; $final = $counter-1; next; }
				if($start ne 'all' && $i == $tstart || $mresults < $npp) { $pagelinks .= qq~<strong>$counter</strong>, ~; $nxt = ($tstart+$npp); }
					else { $pagelinks .= qq~<a href="$link-$i/">$counter</a>, ~; }
				++$counter;
				if($counter > $totalpp+$final && $mresults > $smax) { $gbk = $tstart+$smax; if($gbk > $mresults) { $gbk = (int($mresults/$npp)*$npp); } $pagelinks =~ s/, \Z//gsi; $pagelinks .= qq~ <a href="$link-$gbk/">...</a> ~; ++$i; last; }
			}
			if($counter > 2) { $pgs = 's'; }
			$pagelinks =~ s/, \Z//gsi;
			if(($tstart+$npp) != $i && $start ne 'all') { $pagelinks .= qq~ <a href="$link-$nxt/">&#187;</a>~; }

			$onpage = ($tstart+1).' - '.($tstart+$npp);

			$mresults = 0 if($search[0] eq '');

			$ebout .= <<"EOT";
<tr>
 <td colspan="6" class="catbg smalltext"><strong>$gtxt{'17'}:</strong> $pagelinks</td>
</tr>
EOT
		}
	$ebout .= <<"EOT";
</table><br />
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="titlebg"><strong>$moderate[88]</strong></td>
 </tr><tr>
  <td class="win">
   <table cellpadding="2" cellspacing="0" width="100%">
    <tr>
     <td style="width: 50%" class="vtop">
      <table width="100%" cellpadding="5" cellspacing="1" class="border">
       <tr>
        <td class="catbg"><strong>$moderate[89]</strong></td>
       </tr><tr>
        <td class="win2 smalltext"><div class="win" style="padding: 5px;"><div style="float: left"><strong>$moderate[90]</strong></div><div style="float: right"><strong>$moderate[91]</strong></div><br /></div>
        <div style="overflow: auto; width: 100%; height: 200px; margin: 0px;">
         <table cellpadding="5" cellspacing="0" width="100%">
EOT
	foreach(@usrlog) { push(@usrlog2,"$sbuser{$_}|$_"); }
	foreach(sort {$b <=> $a} @usrlog2) {
		($t,$_) = split(/\|/,$_);
		GetMemberID($_);

		$coloruser = $permissions{$membergrp{$_}}{'color'} ? qq~<span style="color: $permissions{$membergrp{$_}}{'color'}"><strong>$memberid{$_}{'sn'}</strong></span>~ : $memberid{$_}{'sn'};

		$usr = $memberid{$_}{'sn'} ? $coloruser : $_;
		$ebout .= qq~<tr><td><a href="$surl\lv-mod/a-modlog/u-$_/">$usr</a></td><td class="right">$sbuser{$_}&nbsp; &nbsp; &nbsp;</td></tr>~;
	}
	$ebout .= <<"EOT";
         </table>
        </div>
        </td>
       </tr>
      </table>
     </td><td></td>
     <td style="width: 50%" class="vtop">
      <table width="100%" cellpadding="5" cellspacing="1" class="border">
       <tr>
        <td class="catbg"><strong>$moderate[92]</strong></td>
       </tr><tr>
        <td class="win2 smalltext"><div class="win" style="padding: 5px;"><div style="float: left"><strong>$moderate[76]</strong></div><div style="float: right"><strong>$moderate[91]</strong></div><br /></div>
EOT

	foreach(@tasklogs) { push(@tasklogs2,"$sbtask{$_}|$_"); }

	foreach(sort {$b <=> $a} @tasklogs2) {
		($t,$_) = split(/\|/,$_);
		$ebout .= qq~<div style="padding: 5px;"><div style="float: left"><a href="$surl\lv-mod/a-modlog/t-$_/">$tasklog[$_-1]</a></div><div style="float: right">$sbtask{$_}</div><br /></div>~;
	}
	$SEL{$FORM{'searchby'}} = ' selected="selected"';

	$ebout .= <<"EOT";
        </td>
       </tr>
      </table>
     </td>
    </tr><tr>
     <td colspan="3">
      <form action="$surl\lv-mod/a-modlog/" method="post">
      <table width="100%" cellpadding="5" cellspacing="1" class="border">
       <tr><td class="win2 smalltext"><strong>$moderate[93] &nbsp; <select name="searchby" style="vertical-align: middle"><option value="1"$SEL{1}>$moderate[94]</option><option value="2"$SEL{2}>$moderate[95]</option><option value="3"$SEL{3}>$moderate[96]</option><option value="4"$SEL{4}>$moderate[97]</option></select> : &nbsp; </strong><input type="text" name="value" value="$FORM{'value'}" style="vertical-align: middle" /> &nbsp; <input type="submit" value="$moderate[98]" style="vertical-align: middle" /></td></tr>
      </table>
      </form>
     </td>
    </tr>
   </table>
  </td>
 </tr>
</table>
EOT

	footer();
	exit;
}

sub MLogging {
	my($mymid,$myid,$myusr,$mytm,$ext,$boardid) = @_;

	$sqlblah = SQL->new('moderatorlog');
	$sqlblah->into('action','user','time','boardfrom','ipaddress','threadid','boardid');
	$sqlblah->insert($myid,$myusr,$mytm,$ext,$ENV{'REMOTE_ADDR'},$mymid,$boardid);
}

sub KillGroups {
	my(@massuser);
	error($moderate[103]) if($disabledel && !$members{'Administrator',$username});

	@massuser = split(',',$_[0]);

	GetMassUsers(@massuser);

	foreach(@massuser) {
		next if($memberid{$_}{'sn'} eq '');

		$killgroup{$_} = 1;

		$oldlog = SQL->new('oldnames');
		$oldlog->into('id','name');
		$oldlog->insert($_,$memberid{$_}{'sn'});

		if($memberid{$_}{'avatarupload'}) {
			$memberid{$_}{'avatar'} =~ s/$uploadurl\///gsi;
			unlink("$uploaddir/$memberid{$_}{'avatar'}");
		}

		$sql = SQL->new('memberlog');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('members');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('notify');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('pm');
		$sql->where('owner');
		$sql->delete($_);

		$sql = SQL->new('pmfolders');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('pmprefs');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('polllog');
		$sql->where('userid');
		$sql->delete($_);

		$sql = SQL->new('events');
		$sql->where('userid');
		$sql->delete($_);

		MLogging($_,9,$username,time,'',$_[1],$memberid{$_}{'sn'});
	}

	$sql = Cache->new();
	$sql->delete('oldmembers');

	$sql = SQL->new('members');
	$sql->columns('userid');
	$sql->limit();
	$memtotal = $sql->count();
	$sql->limit(0,1);
	$sql->order('userid|DESC');
	%lastmember = $sql->select();
	$lastmem = $sql->{_varval};

	$sql = Cache->new();
	$sql->delete('stats');

	$sql = SQL->new('settings');
	$sql->where('variable');
	$sql->set('value');
	$sql->update($memtotal,'membertotal');
	$sql->update($lastmember{$lastmem}{'userid'},'lastmember');

	foreach $grp (@fullgroups) {
		$membersingrp = '';
		foreach(split(',',$permissions{$grp}{'members'})) {
			next if($killgroup{$_});
			$membersingrp .= "$_,";
		}
		$membersingrp =~ s/,\Z//g;

		$membersinwait = '';
		foreach(split(',',$permissions{$grp}{'waiting'})) {
			next if($killgroup{$_});
			$membersinwait .= "$_,";
		}
		$membersinwait =~ s/,\Z//g;

		$membersinman = '';
		foreach(split(',',$permissions{$grp}{'manager'})) {
			next if($killgroup{$_});
			$membersinman .= "$_,";
		}
		$membersinman =~ s/,\Z//g;

		next if($membersinwait eq $permissions{$grp}{'waiting'} && $membersinman eq $permissions{$grp}{'manager'} && $membersingrp eq $permissions{$grp}{'members'});

		$sql = SQL->new('ranks');
		$sql->where('id');
		$sql->set('members','manager','waiting');
		$sql->update($membersingrp,$membersinman,$membersinwait,$grp);

		$sql = Cache->new();
		$sql->delete('ranks');
	}
}
1;