#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################

is_admin();
CoreLoad('ManageBoards',1);

$cache = Cache->new();
$cache->delete('boards');
$cache->delete('categories');

sub ManageCats {
	if($URL{'s'} eq 'save') { CatSave(); }

	$title = "Manage Boards and Categories";
	headerA();
	$ebout .= <<"EOT";
<form action="$surl\lv-admin/a-cats/s-save/" method="post" enctype="multipart/form-data">
<table cellpadding="5" cellspacing="1" class="border" width="98%">
 <tr>
  <td class="titlebg">Manage Categories</td>
 </tr><tr>
  <td style="padding: 0">
   <table cellpadding="8" cellspacing="0" width="100%">
    <tr>
	 <td class="catbg">$managebrds[2]</td>
	 <td class="catbg">$managebrds[3]</td>
	 <td class="catbg">$managebrds[4]</td>
	 <td class="catbg">$managebrds[8]</td>
	 <td class="catbg">$managebrds[9]</td>
	 <td class="catbg center"><img src="$images/ban.gif" alt="" /></td>
	</tr>
EOT
	push(@fullgroups,('member','validating','guest'));
	$permissions{'member'}{'name'} = $managecats[40];
	$permissions{'guest'}{'name'} = $managecats[41];
	$permissions{'validating'}{'name'} = $managecats[42];

	foreach(@catbase) {
		%select = ();
		$select{$cats{$_}{'parent'}} = ' selected="selected"';
		$parents = '';
		foreach $rents (@catbase) {
			next if($_ eq $rents);
			$parents .= qq~<option value="$rents"$select{$rents}>$cats{$rents}{'name'}</option>~;
		}
		$ebout .= <<"EOT";
<tr>
 <td class="win vtop"><input type="text" name="name_$_" value="$cats{$_}{'name'}" /></td>
 <td class="win vtop center"><input type="text" name="order_$_" value="$cats{$_}{'order'}" size="5" /></td>
 <td class="win2 vtop"><select name="parent_$_"><option value="0"$select{0}>Root</option>$parents</select></td>
 <td class="win vtop"><textarea name="desc_$_" rows="3" cols="10" style="width: 95%;">$cats{$_}{'description'}</textarea></td>
 <td class="win3 vtop center"><select name="memgrp_$_" size="6" style="width: 90%" multiple="multiple">
EOT
	%t2 = ();
	foreach $tmp (split(',',$cats{$_}{'permissions'})) { $t2{$tmp} = ' selected="selected"'; }
	$ebout .= qq~<optgroup label="$managecats[31]">~;
	foreach $tmp (@fullgroups) {
		if($tmp eq 'Moderators') { next; }
		if($tmp eq 'member') { $ebout .= qq~</optgroup><optgroup label="$managecats[32]">~; }
		$ebout .= qq~<option value="$tmp"$t2{$tmp}>$permissions{$tmp}{'name'}</option>~;
	}

	$ebout .= <<"EOT";
  </optgroup></select>
 </td>
 <td class="win2 vtop center"><input type="checkbox" name="del_$_" value="1" /></td>
</tr>
EOT
	}

	$parents = '';
	foreach $rents (@catbase) {
		$parents .= qq~<option value="$rents">$cats{$rents}{'name'}</option>~;
	}

	$ebout .= <<"EOT";
<tr>
 <td colspan="6" class="titlebg">$managebrds[10]</td>
</tr><tr>
 <td class="win vtop"><input type="text" name="name_new" /></td>
 <td class="win vtop center"><input type="text" name="order_new" size="5" /></td>
 <td class="win2 vtop"><select name="parent_new"><option value="0" selected="selected">Root</option>$parents</select></td>
 <td class="win vtop"><textarea name="desc_new" rows="3" cols="10" style="width: 95%;"></textarea></td>
 <td class="win3 vtop center"><select name="memgrp_new" size="6" style="width: 90%" multiple="multiple">
EOT
	%t2 = ();

	$t2{'member'} = ' selected="selected"';
	$t2{'validating'} = ' selected="selected"';
	$t2{'guest'} = ' selected="selected"';

	$ebout .= qq~<optgroup label="$managecats[31]">~;
	foreach $tmp (@fullgroups) {
		if($tmp eq 'Moderators') { next; }
		if($tmp eq 'member') { $ebout .= qq~</optgroup><optgroup label="$managecats[32]">~; }
		$ebout .= qq~<option value="$tmp"$t2{$tmp}>$permissions{$tmp}{'name'}</option>~;
	}

	$ebout .= <<"EOT";
      </optgroup></select>
     </td>
     <td class="win2 center vtop">*</td>
    </tr><tr>
     <td colspan="6" class="win4"><input type="submit" value="$managebrds[6]" /></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
</form>
EOT
	footerA();
	exit;
}

sub CatSave {
	foreach $cat (@catbase) {
		if($FORM{"del_$cat"}) {
			$sql = SQL->new('categories');
			$sql->where('id');
			$sql->delete($cat);
			next;
		}

		$memgrp = '';
		next if($FORM{"name_$cat"} eq '');
		foreach(split(",",$FORM{"memgrp_$cat"})) {
			if($_ eq '') { next; }
			$memgrp .= Format($_).',';
		}
		$memgrp =~ s/,\Z//g;
		$catdesc = Format($FORM{"desc_$cat"});
		$sql = SQL->new('categories');
		$sql->where('id');
		$sql->set('parent','order','name','permissions','description');
		$sql->update($FORM{"parent_$cat"},$FORM{"order_$cat"},Format($FORM{"name_$cat"}),$memgrp,Format($FORM{"desc_$cat"}),$cat);
	}

	if($FORM{'name_new'} ne '') {
		$memgrp = '';
		foreach(split(",",$FORM{"memgrp_new"})) {
			if($_ eq '') { next; }
			$memgrp .= Format($_).',';
		}
		$memgrp =~ s/,\Z//g;

		$sql = SQL->new('categories');
		$sql->into('parent','order','name','permissions','description');
		$sql->insert($FORM{'parent_new'},$FORM{'order_new'},Format($FORM{'name_new'}),$memgrp,Format($FORM{"desc_new"}));
	}

	redirect("$surl\lv-admin/a-cats/");
}

sub ManageBoards {
	if($URL{'s'} eq 'save') { BoardSave(); }
	if($URL{'p'} eq 'modify') { BoardModify(); }

	$title = $managebrds[1];
	headerA();
	$ebout .= <<"EOT";
<form action="$surl\lv-admin/a-boards/p-quick/s-save/" method="post" enctype="multipart/form-data">
<table cellpadding="5" cellspacing="1" class="border" width="98%">
 <tr>
  <td class="titlebg">$managebrds[1]</td>
 </tr><tr>
  <td style="padding: 0">
   <table cellpadding="8" cellspacing="0" width="100%">
    <tr>
	 <td class="catbg center">$managebrds[2]</td>
	 <td class="catbg center">$managebrds[3]</td>
	 <td class="catbg center">$managebrds[4]</td>
	 <td class="catbg center" style="width: 25px">$managebrds[5]</td>
	 <td class="catbg center" style="width: 25px"><img src="$images/ban.gif" /></td>

	</tr>
EOT

	foreach $brd (@boardbase) {
		%select = ();
		$select{$boards{$brd}{'parent'}} = ' selected="selected"';
		$parents = '';
		foreach $rents (@catbase) {
			$parents .= qq~<option value="$rents"$select{$rents}>$cats{$rents}{'name'}</option>~;
		}
		$ebout .= <<"EOT";
    <tr>
	 <td class="win2 center"><a href="$surl\lv-admin/a-boards/p-modify/id-$brd/">$boards{$brd}{'name'}</a></td>
	 <td class="win center"><input type="text" name="order_$brd" value="$boards{$brd}{'order'}" size="5" /></td>
	 <td class="win center"><select name="parent_$brd">$parents</select></td>
	 <td class="win2 center"><a href="$surl\lv-admin/a-boards/p-modify/id-$brd/"><img src="$buttons/modify.png" /></a></td>
	 <td class="win3 center"><input type="checkbox" name="del_$brd" value="1" /></td>
	</tr>
EOT
	}

	$ebout .= <<"EOT";
	<tr>
     <td colspan="5" class="win4"><input type="submit" value="$managebrds[6]" /></td>
    </tr><tr>
     <td colspan="5" class="win3"><img src="$images/add.gif" class="centerimg" alt="" /> <strong><a href="$surl\lv-admin/a-boards/p-modify/id-new/">$managebrds[7]</a></strong></td>
    </tr>
   </table>
  </td>
 </tr>
</table>
</form>
EOT
	footerA();
	exit;
}

sub BoardModify {
	$id = $URL{'id'};

	if($id ne 'new') {
		$E{$boards{$id}{'email'}} = ' checked="checked"';
		$PC{$boards{$id}{'postcount'}} = ' checked="checked"';
		$V{$boards{$id}{'voting'}} = ' checked="checked"';
	
		$boards{$id}{'description'} =~ s/&#47;/\//g;
		$desc = Unformat($boards{$id}{'description'});

		foreach(split(/\|/,$boards{$id}{'moderators'})) {
			if($_ =~ /\((.+?)\)/) { $mods{$1} = ' selected="selected"'; next; }
			GetMemberID($_);
			if($memberid{$_}{'sn'} eq '') { next; }
			$mods .= "$memberid{$_}{'sn'}\n";
		}

		$mods =~ s/,\Z//;
	}

	if($id eq 'new') { $title = $manageboards[11]; }
		else { $title = "$manageboards[12]: $boards{$URL{'id'}}{'name'}"; }

	$boards{$id}{'image'} =~ s/\|/\//g;

	headerA();
	$ebout .= <<"EOT";
<script type="text/javascript">
<!-- Start
function checkAll(type,ucheck) {
 counter = 1;
 for(i = 0; i < document.forms['manage'].elements.length; i++) {
  string = document.forms['manage'].elements[i].name;
  if(string.match(type) && !ucheck) { document.forms['manage'].elements[i].checked = true; }
  else if(string.match(type) && ucheck) { document.forms['manage'].elements[i].checked = false; }
 }
}
// End -->
</script>
<form action="$surl\lv-admin/a-boards/p-modify/s-save/id-$URL{'id'}/" id="manage" method="post" enctype="multipart/form-data">
<table cellpadding="5" cellspacing="1" class="border" width="98%">
 <tr>
  <td class="titlebg"><strong><img src="$images/thread.gif" alt="" /> $title</strong></td>
 </tr><tr>
  <td class="win smalltext">$manageboards[54]</td>
 </tr><tr>
  <td class="catbg smalltext center"><strong>$manageboards[52]</strong></td>
 </tr><tr>
  <td class="win2">
   <table cellpadding="5" cellspacing="0" width="100%">
    <tr>
     <td class="right" style="width: 35%"><strong>$manageboards[13]:</strong></td>
     <td style="width: 65%" class="vtop"><input type="text" name="bname" value="$boards{$id}{'name'}" size="30" /></td>
    </tr><tr>
     <td style="width: 35%" class="vtop right"><strong>$manageboards[15]:</strong></td>
     <td style="width: 65%" class="vtop"><textarea name="bdisc" style="width: 90%; height: 50px;" rows="1" cols="1">$desc</textarea></td>
    </tr><tr>
	 <td class="right"><strong>$managebrds[4]:</strong></td>
EOT
		%select = ();
		$select{$boards{$id}{'parent'}} = ' selected="selected"';
		$parents = '';
		foreach $rents (@catbase) {
			$parents .= qq~<option value="$rents"$select{$rents}>$cats{$rents}{'name'}</option>~;
		}
	$ebout .= <<"EOT";
	 <td><select name="parent">$parents</select></td>
    </tr><tr>
	 <td class="right"><strong>$managebrds[3]:</strong></td>
	 <td><input type="text" name="order" value="$boards{$id}{'order'}" size="5" /></td>
	</tr><tr>
     <td class="right" style="width: 35%"><strong>$managecats[33]:</strong></td>
     <td style="width: 65%"><input type="text" name="bgfx" value="$boards{$id}{'image'}" size="50" /></td>
    </tr><tr>
     <td style="width: 35%" class="vtop right"><strong>$manageboards[16]:</strong><div class="smalltext">$manageboards[17]</div></td>
     <td style="width: 65%" class="vtop">
      <table cellpadding="2" cellspacing="0" width="100%">
       <tr>
        <td style="width: 50%"><textarea name="mods" rows="5" cols="35" style="width: 95%;">$mods</textarea></td>
        <td style="width: 50%"><select size="5" name="mods2" style="width: 100%" multiple="multiple"><optgroup label="$managecats[31]">
EOT
	foreach(@fullgroups) {
		if($_ eq 'Moderators') { next; }
		$ebout .= qq~<option value="$_"$mods{$_}>$permissions{$_}{'name'}</option>~;
	}

	$ebout .= <<"EOT";
        </optgroup></select></td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="catbg smalltext center"><strong>$manageboards[53]</strong></td>
 </tr><tr>
  <td class="win" style="padding:0px">
   <table cellpadding="6" cellspacing="0" width="100%">
    <tr class="titlebg">
     <td class="center" style="width: 30%"><strong>$managecats[34]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[35]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[36]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[37]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[43]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[38]</strong></td>
     <td class="center" style="width: 11%"><strong>$managecats[39]</strong></td>
    </tr>
    </table>
   </td>
 </tr><tr>
  <td class="win" style="padding:0px;">
   <div style="overflow: auto; width: 100%; height: 200px;">
   <table cellpadding="6" cellspacing="0" width="100%" class="innertable">
    <tr class="catbg">
     <td colspan="7"><i><strong>$managecats[31]</strong></i></td>
    </tr>
EOT
	if($id eq 'new') {
		$boards{$id}{'poll_perm'} = $boards{$id}{'upload_perm'} = $boards{$id}{'read_perm'} = $boards{$id}{'access_perm'} = $boards{$id}{'start_perm'} = $boards{$id}{'reply_perm'} = 'guest,member,validating';
	}

	foreach(split(',',$boards{$id}{'start_perm'})) { $start{$_} = ' checked="checked"'; }
	foreach(split(',',$boards{$id}{'reply_perm'})) { $reply{$_} = ' checked="checked"'; }
	foreach(split(',',$boards{$id}{'access_perm'})) { $allow{$_} = ' checked="checked"'; }
	foreach(split(',',$boards{$id}{'read_perm'})) { $read{$_} = ' checked="checked"'; }
	foreach(split(',',$boards{$id}{'upload_perm'})) { $upload{$_} = ' checked="checked"'; }
	foreach(split(',',$boards{$id}{'poll_perm'})) { $polls{$_} = ' checked="checked"'; }

	push(@fullgroups,('member','validating','guest'));
	$permissions{'member'}{'name'} = $managecats[40];
	$permissions{'guest'}{'name'} = $managecats[41];
	$permissions{'validating'}{'name'} = $managecats[42];

	$count = 1;
	foreach(@fullgroups) {
		if($_ eq 'Moderators') { next; }
		if($_ eq 'member') { $ebout .= qq~<tr class="catbg"><td colspan="7"><i><strong>$managecats[32]</strong></i></td></tr>~; }

		if($URL{'n'} && ($_ eq 'member' || $_ eq 'guest' || $_ eq 'validating')) {
			$start{$_} = ' checked="checked"';
			$reply{$_} = ' checked="checked"';
			$allow{$_} = ' checked="checked"';
			$read{$_} = ' checked="checked"';
			$upload{$_} = ' checked="checked"';
			$polls{$_} = ' checked="checked"';
		}

		$ebout .= <<"EOT";
<tr>
 <td class="win3" style="width: 30%"><span style="float: left">$permissions{$_}{'name'}</span><span style="float: right"><a href="javascript:checkAll('_$_',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('_$_',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></span></td>
 <td class="center" style="width: 11%"><input type="checkbox" name="start_$_" value="1"$start{$_} /></td>
 <td style="width: 11%" class="win2 center"><input type="checkbox" name="reply_$_" value="1"$reply{$_} /></td>
 <td class="center" style="width: 11%"><input type="checkbox" name="allow_$_" value="1"$allow{$_} /></td>
 <td style="width: 11%" class="win2 center"><input type="checkbox" name="read_$_" value="1"$read{$_} /></td>
 <td class="center" style="width: 11%"><input type="checkbox" name="polls_$_" value="1"$polls{$_} /></td>
 <td style="width: 11%" class="win2 center"><input type="checkbox" name="upload_$_" value="1"$upload{$_} /></td>
</tr>
EOT
		++$count;
	}

	$ebout .= <<"EOT";
   </table></div>
  </td>
 </tr><tr>
  <td class="win" style="padding:0px">
   <table cellpadding="6" cellspacing="0" width="100%">
    <tr class="win">
     <td style="width: 30%" class="center"><a href="javascript:checkAll('_',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('_',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('start',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('start',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('reply',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('reply',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('allow',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('allow',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('read',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('read',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('polls',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('polls',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
     <td class="center" style="width: 11%"><a href="javascript:checkAll('upload',0);"><img src="$images/add.gif" style="vertical-align: middle;" alt="" /></a> &nbsp; <a href="javascript:checkAll('upload',1);"><img src="$images/minus.gif" style="vertical-align: middle;" alt="" /></a></td>
   </tr>
   </table>
  </td>
 </tr><tr>
  <td class="catbg smalltext center"><strong>$managecats[20]</strong></td>
 </tr><tr>
  <td class="win">
   <table cellpadding="5" cellspacing="0" width="100%">
    <tr>
     <td class="center vtop"><input type="checkbox" name="pcnt" value="1"$PC{'1'} /></td>
     <td><strong>$manageboards[63]:</strong><div class="smalltext">$manageboards[64]</div></td>
    </tr><tr>
     <td class="center vtop"><input type="checkbox" name="email" value="1"$E{'1'} /></td>
     <td><strong>$manageboards[26]</strong><div class="smalltext">$manageboards[27]</div></td>
    </tr><tr>
     <td class="center vtop"><input type="checkbox" name="voting" value="1"$V{'1'} /></td>
     <td><strong>$managecats[21]</strong></td>
    </tr><tr>
     <td colspan="2"><strong>$managecats[24]:</strong></td>
    </tr><tr>
     <td colspan="2" class="smalltext" style="padding-left: 25px;"><input type="text" name="redirurl" value="$boards{$id}{'redirect'}" size="50" /><br />$managecats[25]</td>
    </tr><tr>
     <td colspan="2"><strong>$manageboards[24]:</strong></td>
    </tr><tr>
     <td colspan="2" style="padding-left: 25px;"><input type="password" name="boardpassword" value="$boards{$id}{'password'}" size="15" /></td>
    </tr><tr>
     <td colspan="2"><img src="$images/archive_lock.gif" class="centerimg" alt="" /> <strong>$managecats[44]:</strong></td>
    </tr><tr>
     <td colspan="2" class="smalltext" style="padding-left: 25px;"><input type="text" name="archive" value="$boards{$id}{'archived'}" size="15" /><br />$managecats[45]</td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="win2 center"><input type="submit" name="submit" value=" $manageboards[28] " />$remove</td>
 </tr>
</table>
</form>
EOT
	footerA();
	exit;
}

sub BoardSave {
	if($URL{'p'} eq 'quick') {
		foreach $brd (@boardbase) {
			if($FORM{"del_$brd"}) {
				$sql = SQL->new('boards');
				$sql->where('id');
				$sql->delete($brd);
				next;
			}

			$sql = SQL->new('boards');
			$sql->where('id');
			$sql->set('order','parent');
			$sql->update($FORM{"order_$brd"},Format($FORM{"parent_$brd"}),$brd);
		}
	} else {
		$id = $URL{'id'};

		$desc = Format($FORM{'bdisc'});
		$desc =~ s/\//&#47;/g;
		$bname = Format($FORM{'bname'});
		$bname =~ s/\//&#47;/g;
		if($FORM{'boardpassword'} ne $boards) {
			if($FORM{'boardpassword'} =~ s/[#|%^\\{}\/?~'\)\(\]\[\;]//) { error($manageboards[30]); }
			$password = Format($FORM{'boardpassword'});
			if($password ne '') {
				$password = crypt($password,$pwcry);
				$password =~ s/\///g;
			}
		} else { $password = $oldpass; }

		if($FORM{'mods'} ne '') {
			foreach(split(/\n/,$FORM{'mods'})) {
				$_ =~ s/\cM//g;
				if($_ eq '') { next; }
				$modss .= FindUsername($_) || error("$_ $manageboards[31]");
				$modss .= '|';
			}
		}

		if($FORM{'mods2'} ne '') {
			foreach(split(',',$FORM{'mods2'})) { $modss .= "($_)|"; }
		}
		$modss =~ s/\|\Z//g;
	
		$redirurl = $FORM{'redirurl'};
		$redirurl =~ s/\//&#47;/g;
	
		$bgfx = $FORM{'bgfx'};
		$bgfx =~ s/\//\|/g;
	
		# Do the permissions:
		while(($name,$value) = each(%FORM)) {
			if($name =~ /start_(.*?)\Z/ && $value == 1) { $startthreads .= "$1,"; }
			if($name =~ /reply_(.*?)\Z/ && $value == 1) { $replythreads .= "$1,"; }
			if($name =~ /allow_(.*?)\Z/ && $value == 1) { $allowaccess .= "$1,"; }
			if($name =~ /read_(.*?)\Z/ && $value == 1) { $readmess .= "$1,"; }
			if($name =~ /upload_(.*?)\Z/ && $value == 1) { $upload .= "$1,"; }
			if($name =~ /polls_(.*?)\Z/ && $value == 1) { $polls .= "$1,"; }
		}
		$allowaccess =~ s/,\Z//g;
		$replythreads =~ s/,\Z//g;
		$startthreads =~ s/,\Z//g;
		$readmess =~ s/,\Z//g;
		$upload =~ s/,\Z//g;
		$polls =~ s/,\Z//g;

		if($desc eq '' || $bname eq '') { error($gtxt{'bfield'}); }

		$sql = SQL->new('boards');

		if($boards{$id}{'name'} ne '') {
			$sql->where('id');
			$sql->set('order','parent','description','moderators','name','start_perm','reply_perm','poll_perm','password','email','postcount','access_perm','voting','upload_perm','redirect','image','read_perm','archived');
			$sql->update($FORM{'order'},$FORM{'parent'},$desc,$modss,$bname,$startthreads,$replythreads,$polls,$password,$FORM{'email'},$FORM{'pcnt'},$allowaccess,$FORM{'voting'},$upload,$redirurl,$bgfx,$readmess,$FORM{'archive'},$id);
		} else {
			$sql->into('order','parent','description','moderators','name','start_perm','reply_perm','poll_perm','password','email','postcount','access_perm','voting','upload_perm','redirect','image','read_perm','archived');
			$sql->insert($FORM{'order'},$FORM{'parent'},$desc,$modss,$bname,$startthreads,$replythreads,$polls,$password,$FORM{'email'},$FORM{'pcnt'},$allowaccess,$FORM{'voting'},$upload,$redirurl,$bgfx,$readmess,$FORM{'archive'});
		}
	}
	redirect("$surl\lv-admin/a-boards/");
}
1;