#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################

CoreLoad('MessageIndex',1);

sub MessageIndex {
	my(@massusers);

	$boardurl = $URL{'b'};
	error($ltxt[5]) if($boardurl eq '');

	# How many page links?
	$tmax = $totalpp*20;
	$startdot = ($totalpp*2)/5;

	BoardProperties();

	($pagelinks,$tstart) = PageLinks($boards{$URL{'b'}}{'threads'},$maxdis,'b');

	$sqlselect = SQL->new('topics','id');
	$sqlselect->where('boardid');
	$sqlselect->limit($tstart,$maxdis);
	$sqlselect->order('sticky|DESC','lasttime|DESC');
	%messages = $sqlselect->select($URL{'b'});
	@mlata2 = $sqlselect->col_array();

	foreach(@mlata2) {
		push(@massusers,$messages{$_}{'startuser'},$messages{$_}{'lastuser'});
	}

	foreach(@activeusers) {
		($user,$g,$brd) = split(/\|/,$_);
		next if($g || $brd ne $URL{'b'});
		push(@massusers,$user);
	}
	if($boards{$URL{'b'}}{'moderators'} ne '') {
		foreach(split(/\|/,$boards{$URL{'b'}}{'moderators'})) {
			next if($_ =~ /\((.+?)\)/);
			push(@massusers,$_);
		}
	}

	GetMassUsers(@massusers);

	LogPage();

	if($username ne 'Guest') { $maread = qq~<a href="$scripturl\lv-mark/l-bdis/">$messageindex[45]</a>~; }
	$title = $boardnm;
	header();
	Mods();
	if($modz) { $modz = "<strong>$ltxt[7]:</strong> $modz"; }

	$ratewid = 6;
	if($members{'Administrator',$username} || $ismod) { ++$ratewid; }

	$ebout .= <<"EOT";
<script type="text/javascript">
<!-- Start
function checkAll() {
 shortname = document.forms['messageindex'];
 if(shortname.checkall.checked) { cvalue = true; } else { cvalue = false; }
 for(i = 0; i < shortname.elements.length; i++) {
  if(shortname.elements[i].name == 'opt1') { return; }
  shortname.elements[i].checked = cvalue;
 }
}
// End -->
</script>

<table cellpadding="1" cellspacing="1" width="100%" class="border">
 <tr>
  <td class="win">
   <table cellpadding="6" cellspacing="0" width="100%">
    <tr>
     <td><img src="$images/crumbs.png" class="centerimg" alt="" /> <a href="$surl">$mbname</a> &nbsp;<strong>&rsaquo;</strong> &nbsp;<a href="$surl\lc-$catid/">$catname</a> &nbsp;<strong>&rsaquo; &nbsp;$boardnm</strong></td>
     <td class="right smalltext">$modz</td>
    </tr>
   </table>
  </td>
 </tr>
EOT
	if($showactive) {
		GetActiveUsers();
		$ebout .= <<"EOT";
 <tr>
  <td class="win smalltext">
   <div class="win2" style="padding: 6px"><strong>$var{'90'}</strong></div>
   <div style="padding: 6px">$memberson $var{'97'} $gcnt $var{'91'}</div>
  </td>
 </tr>
EOT
	}
	$ebout .= <<"EOT";
</table><br />
EOT
	if($showdes && $boards{$URL{'b'}}{'description'} ne '') {
		if($boards{$URL{'b'}}{'image'}) {
			$boards{$URL{'b'}}{'image'} =~ s/\|/\//g;
			$boards{$URL{'b'}}{'image'} = $boards{$URL{'b'}}{'image'} =~ /http:\/\// ? $boards{$URL{'b'}}{'image'} : "$images/$boards{$URL{'b'}}{'image'}";
			$boards{$URL{'b'}}{'image'} = qq~<img src="$boards{$URL{'b'}}{'image'}" style="vertical-align: middle;" alt="" /> ~;
		}

		$message = $boards{$URL{'b'}}{'description'};
		$message =~ s/&#47;/\//gsi;
		$message = BC($message);
		$ebout .= <<"EOT";
<table cellpadding="8" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="win">$boards{$URL{'b'}}{'image'} $message</td>
 </tr>
</table><br />
EOT
	}

	if($members{'Administrator',$username} || $ismod) { $ebout .= qq~<form action="$surl\lb-$URL{'b'}/v-mod/a-mindex/" id="messageindex" method="post">~; $endform = qq~</form>~; }

	$stata = !$tallow || !$repallow ? 'locked' : 'thread';
	if($tallow) { $allowposts = qq~<a href="$surl\lv-post/b-$URL{'b'}/" rel="nofollow">$Iimg{'newthread'}</a>$spoll~; }

	if($username ne 'Guest' && !$nonotify) { $notify .= qq~ | <a href="$surl\lv-memberpanel/a-notify/m-brd/b-$URL{'b'}/">$messageindex[46]</a>~; }

	$ebout .= <<"EOT";
<table cellpadding="0" cellspacing="0" width="100%" style="margin-bottom: 5px;">
 <tr>
  <td class="indextitle">$boardnm</td>
  <td class="right indexmenu">$allowposts</td>
 </tr>
</table>
<table cellpadding="5" cellspacing="1" class="border" width="100%">
 <tr>
  <td class="catbg" colspan="$ratewid" style="padding: 8px">
   <table cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td class="pages">$totalpages $gtxt{'45'} $pagelinks</td>
     <td class="right normaltext">$maread$notify</td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td class="titlebg center" style="padding: 7px"><a href="$surl\lv-shownews/a-feed/b-$URL{'b'}/"><img src="$images/feed.png" alt="" /></a></td>
  <td class="titlebg smalltext" style="width: 40%"><strong>$messageindex[9]</strong></td>
  <td class="titlebg smalltext center" style="width: 8%"><strong>$gtxt{'38'}</strong></td>
  <td class="titlebg smalltext center" style="width: 15%"><strong>$gtxt{'36'}</strong></td>
  <td class="titlebg smalltext center" style="width: 8%"><strong>$messageindex[11]</strong></td>
  <td class="titlebg smalltext center" style="width: 25%"><strong>$messageindex[12]</strong></td>
EOT

	if($members{'Administrator',$username} || $ismod) { $ebout .= qq~<td class="titlebg smalltext center" style="padding: 5px;"><strong>$messageindex[34]</strong></td>~; }

	$ebout .= '</tr>';

	$end = $URL{'s'} eq 'all' ? $maxm : $tstart+$maxdis;

	foreach $fmess (@mlata2) {
		$poll = $messages{$fmess}{'poll'};
		$type = $messages{$fmess}{'type'};
		$stickme{$fmess} = 1 if($messages{$fmess}{'sticky'});

		$pviews = MakeComma($messages{$fmess}{'views'});

		$replies = $messages{$fmess}{'replies'};
		$statuscng = 0;
		$status = FindStatus($messages{$fmess}{'lasttime'});
		if(!$stuck && $status =~ /sticky/) {
			$statuscng = $messageindex[24];
			$sticks = "<strong>$messageindex[26]:</strong> ";
			$stuck = 1;
		}
		if($stuck && $status !~ /sticky/) {
			$statuscng = $messageindex[25];
			$sticks = '';
			$stuck = 0;
		}

		if($statuscng) {
			$ebout .= <<"EOT";
 <tr>
  <td class="win5 smalltext" colspan="$ratewid"><strong>$statuscng</strong></td>
 </tr>
EOT
		}

		$poll = !$sticks && $status eq 'poll_icon' ? "<strong>$var{'67'}:</strong> " : '';

		if($username ne 'Guest') {
			$new = '';
			$yay = 0;
			$tempurl = '';
			if(($logged{"m$fmess"}{'visited'}-$messages{$fmess}{'lasttime'}) <= 0 && ($logged{"AllRead_$URL{'b'}"}{'visited'}-$messages{$fmess}{'lasttime'}) <= 0 && ($logged{"AllBoards"}{'visited'}-$messages{$fmess}{'lasttime'}) <= 0) { $new = qq~<div style="font-weight: bold;"><img src="$images/new.gif" alt="$messageindex[28]" style="margin-right: 3px;margin-left: 3px;" /> ~; $tempurl = "s-new/"; }
				else { $new = "<div>"; }
		} else { $new = "<div>"; }

		GetMemberID($messages{$fmess}{'startuser'});
		$threadstart = $memberid{$messages{$fmess}{'startuser'}}{'sn'} ne '' ? $userurl{$messages{$fmess}{'startuser'}} : FindOldMemberName($messages{$fmess}{'startuser'}) || $var{'60'};
		GetMemberID($messages{$fmess}{'lastuser'});
		$lastuser = $memberid{$messages{$fmess}{'lastuser'}}{'sn'} ne '' ? $userurl{$messages{$fmess}{'lastuser'}} : FindOldMemberName($messages{$fmess}{'lastuser'}) || $var{'60'};

		$messlinks = '';
		if($messages{$fmess}{'replies'} > 50000) { $messages{$fmess}{'replies'} = 50; }

		$URL{'m'} = $fmess;
		($messlinks,$tstart) = PageLinks($messages{$fmess}{'replies'},$maxmess,'m','small');
		$messlinks = qq~<div style="padding-top: 5px;">$gtxt{'17'}: $messlinks</div>~ if($messlinks);

		$replies = MakeComma($messages{$fmess}{'replies'});

		$date = get_date($messages{$fmess}{'lasttime'});
		$startdate = get_date($messages{$fmess}{'creationtime'},1);
		$messtitle = CensorList($messages{$fmess}{'subject'});

		$icon = '';
		if($messages{$fmess}{'icon'} ne 'xx.gif' && $messages{$fmess}{'icon'} ne 'xx.png') { $icon = qq~<td style="width: 20px" class="center"><img src="$images/icons/$messages{$fmess}{'icon'}" alt="" />&nbsp;</td>~; }

		$status = 'moved' if($movedsubject && $messages{$fmess}{'moveid'} ne '');

		$ebout .= <<"EOT";
<tr>
 <td class="win3 center" style="padding-left: 10px; padding-right: 10px;">&nbsp;<img src="$images/$status.gif" alt="" />&nbsp;</td>
EOT
		if($messages{$fmess}{'moveid'} ne '') {
			$ebout .= <<"EOT";
 <td class="win"><strong>$messageindex[39]:</strong> <a href="$surl\lm-$messages{$fmess}{'moveid'}/">$messtitle</a></td>
 <td class="win2 center smalltext" colspan="3"><i>$messageindex[38]</i></td>
EOT
		} else {
			$ebout .= <<"EOT";
 <td class="win">$new$sticks$poll <a href="$surl\lm-$fmess/$tempurl" title="$messageindex[15]: $startdate">$messtitle</a></div>$messlinks</td>
 <td class="win2 smalltext center" style="width: 8%">$replies</td>
 <td class="win smalltext center" style="width: 15%">$threadstart</td>
 <td class="win2 smalltext center" style="width: 8%">$pviews</td>
EOT
		}
		$ebout .= <<"EOT";
 <td class="win" style="width: 25%">
  <table width="100%">
   <tr>
    <td class="smalltext">
     <div class="milastaction">$messageindex[16] $lastuser</div><div class="midate">$date</div>
    </td>$icon
   </tr>
  </table>
 </td>
EOT
		if($members{'Administrator',$username} || $ismod) { ++$scounter; $ebout .= qq~<td class="win3 center" style="width: 5%"><input type="checkbox" name="$scounter" value="$fmess" /></td>~; }
		$ebout .= "</tr>";
	}
	if(!$lastuser) {
		if($URL{'n'}) { $messageindex[17] = $messageindex[23]; }
		$ebout .= <<"EOT";
<tr>
 <td class="win center" colspan="$ratewid"><br />$messageindex[17]<br /><br /></td>
</tr>
EOT
	}
	$GoBoards = ListBoards();
	if($allowposts eq '' && $maread eq '') { $lck = qq~<img src="$images/locked.gif" alt="" /> $messageindex[36]~; }

	if($members{'Administrator',$username} || $ismod) {
		if($sessionEnabled && (!$session->param('admin_login') || $session->param('adminverify') ne $memberid{$username}{'adminverify'})) {
			$ebout .= <<"EOT";
<tr>
 <td class="catbg smalltext right" colspan="$ratewid"><a href="$surl\lv-admin/a-verify/">$messageindex[47]</a></td>
</tr>
EOT
		} else {
			$temp = $grood = '';
			SubCatsList(0,'',$URL{'b'});
			$ops = $temp;
	
			if($grood) { $move = qq~&nbsp; <input type="checkbox" value="1" name="opt4" /> $messageindex[29]: <select name="b">$ops</select>~; }
			$ratewid2 = $ratewid-1;
			$ebout .= <<"EOT";
<tr>
 <td class="catbg smalltext right" colspan="$ratewid2"><strong><input type="checkbox" value="1" name="opt1" /> $messageindex[30] &nbsp; <input type="checkbox" value="1" name="opt2" /> $messageindex[31] &nbsp; <input type="checkbox" value="1" name="opt3" /> $messageindex[32] $move&nbsp;</strong> <input type="submit" value="$messageindex[33]" /></td>
 <td class="catbg center"><input type="checkbox" name="checkall" onclick="checkAll();" /></td>
</tr>
EOT
		}
	}

	$loggedinq = $username ne 'Guest' ? qq~<div class="win2" style="float: right; padding: 7px;"><strong>$messageindex[41]:</strong> <a href="$scripturl\ln-1/">$messageindex[42]</a> | <a href="$scripturl">$messageindex[43]</a> | <a href="$surl\lv-search/p-newposts/">$messageindex[44]</a></div>~ : '';

	$ebout .= <<"EOT";
 <tr>
  <td class="catbg" colspan="$ratewid" style="padding: 8px">
   <table cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td class="pages">$totalpages $gtxt{'45'} $pagelinks</td>
     <td class="right normaltext">$maread$notify</td>
    </tr>
   </table>
  </td>
 </tr>
</table>
<table cellpadding="0" cellspacing="0" width="100%" style="margin-top: 5px;">
 <tr>
  <td class="right indexmenu">$allowposts</td>
 </tr>
</table>
$endform
<br />

<div style="padding: 1px;" class="border">
 <table cellpadding="0" cellspacing="0" class="win" width="100%">
  <tr>
   <td style="padding: 7px"><img src="$images/crumbs.png" class="centerimg" alt="" /> <a href="$surl">$mbname</a> &nbsp;<strong>&rsaquo;</strong> &nbsp;<a href="$surl\lc-$catid/">$catname</a> &nbsp;<strong>&rsaquo; &nbsp;$boardnm</strong></td>
   <td>$loggedinq</td>
  </tr>
 </table>
</div>
<br />

<table cellpadding="6" cellspacing="1" style="float: left; margin: 0px;">
 <tr>
  <td class="center" style="width: 15px"><img src="$images/thread.gif" alt="" /></td>
  <td class="smalltext">$var{'61'}</td>
  <td class="center" style="width: 15px"><img src="$images/locked.gif" alt="" /></td>
  <td class="smalltext">$var{'62'}</td>
  <td class="center" style="width: 15px"><img src="$images/hotthread.gif" alt="" /></td>
  <td class="smalltext">$var{'63'} ($htdmax+)</td>
 </tr><tr>
  <td class="center"><img src="$images/veryhotthread.gif" alt="" /></td>
  <td class="smalltext">$var{'64'} ($vhtdmax+)</td>
  <td class="center"><img src="$images/sticky.gif" alt="" /></td>
  <td class="smalltext">$var{'65'}</td>
  <td class="center"><img src="$images/sticky_lock.gif" alt="" /></td>
  <td class="smalltext">$var{'66'}</td>
 </tr><tr>
  <td class="center"><img src="$images/poll_icon.gif" alt="" /></td>
  <td class="smalltext">$var{'67'}</td>
  <td class="center"><img src="$images/poll_sticky.gif" alt="" /></td>
  <td class="smalltext">$var{'68'}</td>
  <td class="center"><img src="$images/poll_lock.gif" alt="" /></td>
  <td class="smalltext">$var{'69'}</td>
 </tr><tr>
  <td class="center"><img src="$images/archive_lock.gif" alt="" /></td>
  <td colspan="5" class="smalltext">$messageindex[40]</td>
 </tr>
</table>

<form action="$surl\lv-search/b-$URL{'b'}/p-bs/" method="post">
<table cellpadding="4" cellspacing="1" width="400" style="float: right; margin: 0px;">
 <tr>
  <td class="right"><input type="hidden" name="searchboards" value="$URL{'b'}" /><input type="text" name="searchstring" class="textinput boardsearch" value="$messageindex[37]" onfocus="if(this.value == '$messageindex[37]') { this.value=''; }" size="30" /></td>
 </tr><tr>
  <td class="right">$GoBoards</td>
 </tr>
</table>
</form>
<div style="clear: both"></div>
EOT
	footer();
	exit;
}
1;