#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################
# Part of the E-Blah Core                   #
#############################################

{
	$pwcry = 'ya'; # If 'ya' is changed, change this also! This is conversion key!
	$pwlength = $encryption == 2 ? 20 : 8; # Max password length, 20 = MD5 encryption style; 8 = other

	$uflock = 1; # File Locking (Dis|En)abler
	$fopen  = 2;
	$fclose = 8;
}

sub fopen {
	my($fh,$fn) = @_;

	if($fn =~ m~/\.\./~) {
		eval { error("OPEN_ERROR",2); };
		die "\n\nYou MUST use absolute paths.\n\n";
	}

	if($debug >= 2) { ++$openedfiles; $openedfilenames .= "$fn ($fh)<br />\n"; }

	open($fh,$fn);
	if($uflock) {
		flock($fh,$fopen);
		seek($fh,0,0);
	} else { return(1); }
}

sub fclose {
	my($fh) = $_[0];
	if($uflock) { flock($fh,$fclose); }
	close($fh);
}

sub CheckCookies { # Find users cookies/SID
	foreach(split(/; /,$ENV{'HTTP_COOKIE'})) {
		$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		($cname,$cval) = split(/=/);
		$Blah{$cname} = $cval;
	}

	$sessionEnabled = 0;
	if($Blah{"$cookpre\_pw"} && ($ensids == 0 || $ensids == 1)) {
		$password = $Blah{"$cookpre\_pw"};
		$username = $Blah{"$cookpre\_un"};
	} else {
		if($ensids) {
			eval { require("CGI/Session.pm"); };
			if($Blah{"$cookpre\_session"} ne '' && !$@) {
				$session = new CGI::Session("driver:File", $Blah{"$cookpre\_session"}, {Directory=>"$prefs/Sessions"});

				$username = $session->param('username');
				$password = $session->param('password');
	
				$sessionEnabled = 1;
			}
		}
	}
	GetUser() if($username ne 'Guest');
	if($URL{'theme'} && $username ne 'Guest') { $usert .= "theme-$URL{'theme'}/"; }

	$scripturl = "$scriptname$modrewrite\lb-$URL{'b'}/$usert";
	$surl = $scriptname.$modrewrite.$usert;
	$rurl = $realurl.$scriptname;

	$rurl .= $modrewrite if($modrewrite eq '?');
}

sub GetUser {
	my($getuserid);

	$getuserid = SQL->new('members','userid');
	$getuserid->where('userid');
	%memberid = $getuserid->select($username);

	if($memberid{$username}{'password'} eq '') { $username = 'Guest'; }

	if($username ne 'Guest') {
		if($yabbconver) { $cryptpw = $memberid{$username}{'password'}; } else { $cryptpw = Encrypt($memberid{$username}{'password'}); }
		if($password ne $cryptpw) { $username = 'Guest'; return(); }

		if($memberid{$username}{'status'}) { $lockuserout = 1; } # Lock user out ... 

		$pmdisable = 1 if($memberid{$username}{'pmdisable'});

		@blockedusers = split(/\|/,$memberid{$username}{'blockedusers'});

		$languagep = $memberid{$username}{'lng'} if($memberid{$username}{'lng'} && -e("$languages/$memberid{$username}{'lng'}.lng"));
	}
}

sub Encrypt {
	if($yabbconver) {
		if($md5upgrade) { $encryption = $memberid{$username}{'md5upgrade'} ? 2 : 1; }
		if($encryption == 2) { # What method?
			require Digest::MD5;
			import Digest::MD5 qw(md5_hex);
			$crypted = md5_hex($_[0]);
			if($memberid{$username}{'salt'}) { $crypted = md5_hex($crypted, $memberid{$username}{'salt'}); }
		} else { $crypted = crypt($_[0],$pwcry); }
	} else { $crypted = $_[0]; }
	return($crypted);
}

sub GetThemes {
	my($sql);

	if($URL{'theme'}) { $memberid{$username}{'theme'} = $URL{'theme'}; }

	CoreLoad('themeslist',2);
	if(!$delcache) {
		$sql = SQL->new('themeslist','id');
		$sql->limit();
		%theme = $sql->select();
		@themeslist = $sql->col_array();

		$sql = Cache->new();
		$sql->hash('theme',%theme);
		$sql->array('themeslist',@themeslist);
		$sql->save('themeslist',1440);
	}

	foreach $themeid (@themeslist) {
		if($theme{$themeid}{'default'} && ($memberid{$username}{'theme'} eq '' || !$showtheme)) { $dtheme = $themeid; }
		if($themeid eq $memberid{$username}{'theme'} && $showtheme) { $dtheme = $themeid; }
		if($dtheme eq '') { $dtheme = $themeid; }
	}

	$oimages = $images; $obuttons = $buttons;

	if($theme{$dtheme}{'images'})  { $images = "$templatesu/$dtheme/images"; }
	if($theme{$dtheme}{'buttons'}) { $buttons = "$templatesu/$dtheme/buttons"; }
}
1;