#############################################
# E-Blah Bulliten Board Systems        2007 #
#############################################
# Copyright (c) 2001 - 2007 E-Blah.         #
#############################################
# Part of the E-Blah Core                   #
#############################################

require("$language/Routines.lng");

{	# Let's work out the dateformat now ...
	if($datedis eq '') { $datedis = 0; }
	if($timedis eq '') { $timedis = 0; }
	if($memberid{$username}{'dateformat'} eq '') { $memberid{$username}{'dateformat'} = $datedis; }
	if($memberid{$username}{'timeformat'} eq '') { $memberid{$username}{'timeformat'} = $timedis; }

	$datedisplayH{0} = 'F j, Y, ';
	$datedisplayH{1} = 'l, F j, Y, ';
	$datedisplayH{2} = 'd F Y, ';
	$datedisplayH{3} = 'm.d.Y, ';
	$datedisplayH{4} = 'd/m/Y, ';
	$datedisplayH{5} = 'Y/m/d, ';

	$timedisplayH{0} = 'g:ia';
	$timedisplayH{1} = 'g:i:sa';
	$timedisplayH{2} = 'H:i';
	$timedisplayH{3} = 'H:i:s';

	if($datedisplayH{$memberid{$username}{'dateformat'}} ne '') { $DateDisplay = $datedisplayH{$memberid{$username}{'dateformat'}}; }
		else { $DateDisplay = $memberid{$username}{'dateformat'}; $memberid{$username}{'timeformat'} = ''; }
	$DateDisplay = "$DateDisplay$timedisplayH{$memberid{$username}{'timeformat'}}";

	# DO NOT REMOVE OR EDIT THE FOLLOWING LINE (unless licensed) ...
	$copyright = qq~Powered by <a href="http://www.eblah.com"$blanktarget>E-Blah Forum Software</a> $versioncr &#169; 2001-2007~;

	# <> - makes it not open .dat files (v10+ should be no issue anyway)
	%botsearch = (
		'mediapartners-google<>' => 'AdSense',
		'googlebot<>'            => 'Googlebot',
		'slurp<>'                => 'Yahoo! Bot',
		'msnbot<>'               => 'MSN Bot',
		'inktomi<>'              => 'Hot Bot',
		'ask jeeves<>'           => 'Ask.com',
		'lycos<>'                => 'Lycos',
		'ia_archiver<>'          => 'Alexa',
		'baiduspider<>'          => 'Baidu Spider',
		'gigabot<>'              => 'Gigabot',
		'googlebot-image<>'      => 'Googlebot-Image',
		'scooter<>'              => 'AltaVista',
		'infoseek<>'             => 'InfoSeek.com',
		'mantraagent<>'          => 'LookSmart.com',
		'voilabot<>'             => 'Voila.fr'
	);

	if($username eq 'Guest') { $memberid{$username}{'timezone'} = $gtzone; }

	$date_time = get_date(time,1);

	my $oldtime = time-86400;
	($t,$t,$t,$Yday,$Ymonth,$Yyear) = gmtime($oldtime+(3600*($memberid{$username}{'timezone'}+$memberid{$username}{'dst'}+$gtoff)));
	($t,$t,$Khour,$Kday,$Kmonth,$Kyear) = gmtime(time+(3600*($memberid{$username}{'timezone'}+$memberid{$username}{'dst'}+$gtoff)));
	$Kyear += 1900;
	$Yyear += 1900;

	if($URL{'v'} eq 'checktime') { CheckTime(); }
}

sub header {
	my($sfoot,$Ecopyright,$sep,$newpms,$header);
	return if($hdone); # Headers have already been completed

	if($ENV{'HTTP_ACCEPT_ENCODING'} !~ /gzip/ && $gzipen) { $gzipen = 0; } # Browser doesn't support gzip

	print "Content-Encoding: gzip\n" if($gzipen);
	print "Content-type: text/html\n\n";

	$hdone = 1;

	# Time of day ...
	if($Khour > 11 && $Khour < 17)  { $wmessage = $rtxt[46]; } # Afternoon
	elsif($Khour <= 12 && $Khour > 2) { $wmessage = $rtxt[45]; } # Morning
		else { $wmessage = $rtxt[47]; } # Evening

	if($username eq 'Guest') {
		$userwelcome = $displayuser = qq~$rtxt[1], <strong>$rtxt[2]</strong>.~;
		$displayuser .= $userpm = qq~$rtxt[3] <a href="$surl\lv-login/" rel="nofollow">$rtxt[4]</a> $rtxt[44] <a href="$surl\lv-register/" rel="nofollow">$rtxt[5]</a>.~; ShowGuest();
	} elsif($lockuserout) {
		$userwelcome = $displayuser = qq~$rtxt[1] $rtxt[9] <strong>$username</strong>.~;
		$displayuser .= $userpm = $rtxt[7];
		$memberid{$username}{'md5upgrade'} = 1;
	} else {
		if(!$pmdisable) {
			if($pmmaxquota && $pmmaxquota-((-s"$members/$username.pm")/1024) < 0) { $userpm = qq~<strong><img src="$images/warning_sm.png" class="centerimg" alt="" /> $rtxt[67] <img src="$images/warning_sm.png" class="centerimg" alt="" /></strong>~; }
				else {
					$memberid{$username}{'pmnew'} = $memberid{$username}{'pmnew'} || 0;
					$memberid{$username}{'pmcnt'} = $memberid{$username}{'pmcnt'} || 0;
					$newpms = qq~ (<strong>$memberid{$username}{'pmnew'} $rtxt[11]</strong>)~ if($memberid{$username}{'pmnew'} > 0);
					$displayuser .= $userpm = qq~ $rtxt[10] <strong>$memberid{$username}{'pmcnt'}</strong>$newpms <a href="$surl\lv-memberpanel/a-pm/" title="$rtxt[12]">$rtxt[13]</a>.~;
				}
		} else { $displayuser .= $userpm = " $rtxt[54]"; }

		$userwelcome = $displayuser = "$wmessage <strong>$memberid{$username}{'sn'}</strong>.";

		if($members{'Administrator',$username} && ($maintance || $lockout)) {
			if($maintance) { $on = $rtxt[14]; }
			if($maintance && $lockout) { $on .= $rtxt[15]; }
			if($lockout) { $on .= $rtxt[16]; }
			$displayuser = $userpm .= qq~<br /><strong><img src="$images/warning_sm.png" alt="" /> $rtxt[17] $on <img src="$images/warning_sm.png" alt="" /></strong>~;
		}
	}

	if($helpdesk) { $help = qq~<a href="$helpdesk" onclick="target='_new';">$Mimg{'help'}</a>~; $sep = $Mmsp2; }

	$homemenu = qq~<a href="$surl">$Mimg{'home'}</a>~;
	#$calmenu = qq~<a href="$surl\lv-cal/" rel="nofollow">$Mimg{'cal'}</a>~;
	$searchmenu = qq~<a href="$surl\lv-search/~; $searchmenu .= "b-$URL{'b'}/" if($URL{'b'}); $searchmenu .= qq~">$Mimg{'search'}</a>~;

	$menubar = '<div class="menubar">'.$homemenu.$sep.$help.$Mmsp2.$calmenu.$Mmsp2.$searchmenu.$Mmsp2;

	if($members{'Administrator',$username}) {
		$adminmenu = qq~<a href="$surl\lv-admin/">$Mimg{'admin'}</a>~;
		$menubar .= $adminmenu.$Mmsp2;
	}

	if($username ne 'Guest') {
		$profilemenu = qq~<a href="$surl\lv-memberpanel/">$Mimg{'profile'}</a>~;
		$loginmenu   = qq~<a href="$surl\lv-login/p-3/" rel="nofollow" onclick="if(window.confirm('$rtxt[65]')) { location = '$surl\lv-login/p-3/'; } return false;">$Mimg{'logout'}</a>~;
		$menubar    .= $profilemenu.$Mmsp2;
	} else {
		$registermenu = qq~<a href="$surl\lv-register/" rel="nofollow">$Mimg{'register'}</a>~;
		$loginmenu    = qq~<a href="$surl\lv-login/" rel="nofollow">$Mimg{'login'}</a>~;
		$menubar     .= $registermenu.$Mmsp2;
	}
	$menubar .= $loginmenu.'</div>';
	
	$lastvisit = get_date($memberid{$username}{'lastvisit'},1);

	# Get the template
	$footer = '';
	fopen(TEMP,"$templates/$dtheme/template.html") or $ebout .= '<strong>Theme not found!</strong><br /><br />';
	while(<TEMP>) {
		$_ =~ s/<blah v="\$(.+?)">/${$1}/gsi;
		if($_ =~ /eblah.com/) { $Ecopyright = 1; }

		if($advancedhtml) {
			if($_ =~ /<\?(.*?)(\Z|\?>)/) {
				$eval = $1;
				if($2 eq '?>') { $keepevaling = 0; eval $eval; } else { $keepevaling = 1; }
				next;
			}
			if($keepevaling && $_ =~ /(.*?)(\Z|\?>)/) {
				$eval .= $1;
				if($2 eq '?>') {
					$keepevaling = 0;
					eval $eval;
					$ebout .= qq~$@~ if($@ ne '');
					$eval = '';
				}
				next;
			}
		}

		if($_ =~ /(.*?)<blah main>(.*?)\Z/) { $sfoot = 1; $header .= $1; $footer .= $2; next; }
		if(!$sfoot) { $header .= $_; } else { $footer .= $_; }
	}
	fclose(TEMP);
	if($dtheme eq '') { $Ecopyright = 1; }

	$ebout .= $header;

	if(-e("$root/Install.pl") && $members{'Administrator',$username}) { $ebout .= '<h1>Please remove Install.pl from the installation directory.</h1>'; }

	if(!$Ecopyright && $URL{'v'} ne 'admin') { $footer = "$copyright<br />$footer"; }

	# Guest?
	$ebout .= $guestlogin if(!$gdisable && $username eq 'Guest');

	$ebout .= $URL{'v'} ne 'memberpanel' && $memberid{$username}{'pmpopup'} && $memberid{$username}{'pmnew'} > 0 ? qq~<script type="text/javascript">if(window.confirm("$rtxt[59] $memberid{$username}{'pmnew'} $rtxt[58]")) { location = "$surl\lv-memberpanel/a-pm/"; }</script>~ : '';

	if($md5upgrade && !$memberid{$username}{'md5upgrade'} && $username ne 'Guest') { CoreLoad('Login'); ChangePass(); }

	if($lockuserout ne '') { CoreLoad('BoardLock'); UserLockOut(); }
}

sub footer {
	ExtClose() if($uextlog);

	if($memberid{$username}{'sn'} ne '' && $logactive) {
		($totaltime,$lasttime) = split(/\|/,$memberid{$username}{'rndsid'});
		if($keepon && $lasttime) { $totaltime += (time-$lasttime); }

		%addtoID = (
			'lastactive' => time,
			'rndsid'     => "$totaltime|".time
		);
		if(time > $memberid{$username}{'lastactive'}+1800) { $addtoID{'lastvisit'} = $memberid{$username}{'lastactive'}; }

		SaveMemberID($username);
	}

	if($debug && $members{'Administrator',$username}) { # Debug, remove in finals
		if($start_debug) { $time_running = sprintf("%.4f",Time::HiRes::time() - $start_debug); }
		$gzipend = $gzipen ? 'Enabled' : 'Disabled';

		if($^O eq 'linux') {
			$uptime = `uptime`;
			($t,$la) = split("load average:",$uptime);
			($five) = split(", ",$la);
		}

		($sqlinsert,$sqlupdate,$sqlselect,$sqldelete,$stats) = SQL->stats();
		$sqltotal = $sqlinsert+$sqlupdate+$sqlselect+$sqldelete;

		$ebout .= qq~<div style="text-align: center"><br /><img src="$images/clock.png" class="centerimg" alt="" /> $time_running seconds &nbsp; <img src="$images/files.png" class="centerimg" alt="" /> $cachedqueries cached queries &nbsp; <img src="$images/files.png" class="centerimg" alt="" /> Queries: $sqlselect ($sqltotal\lti, $sqlinsert\i, $sqlupdate\lu, $sqldelete\d) &nbsp; <img src="$images/gzip.png" class="centerimg" alt="" /> $gzipend &nbsp; <img src="$images/cpu.png" class="centerimg" alt="" /> $five</div>$openedfilenames<br />$stats~;
		if($debug == 2 || $debug == 4) { sleep(5); }
	}

	$ebout .= $footer;

	if($gzipen) {
		if($gzipen == 2) {
			open(GZIP,"| gzip -f");
			print GZIP $ebout;
			close(GZIP);
		} else {
			require Compress::Zlib;
			binmode STDOUT;
			print Compress::Zlib::memGzip($ebout);
		}
	} else { print $ebout; }

	SQL::sqlclose;
}

sub AL {
	my($buser,$luser,$ltime,@maxlog,$getlist,$guest);
	$guest = 0;

	if($username eq 'Guest') {
		if($ENV{'HTTP_USER_AGENT'} =~ /(voilabot|mantraagent|infoseek|mediapartners-google|googlebot|inktomi|ask jeeves|lycos|ia_archiver|slurp|msnbot|baiduspider|gigabot|googlebot-image|scooter)/i) { $buser = lc($1).'<>'; }
			else { $buser = $ENV{'REMOTE_ADDR'}; }
		$guest = 1;
	} else { $buser = $username; }

	$getlist = SQL->new('activelist');
	$getlist->where('time|<|OR','user|=');
	$getlist->delete(time-(60*$activeuserslog),$buser);

	if($buser ne '') {
		$getlist = SQL->new('activelist');
		$getlist->into('time','guest','user','view','boardid','messageid');
		$getlist->insert(time,$guest,$buser,$URL{'v'},$URL{'b'},$URL{'m'});
	}

	$getlist = SQL->new('activelist','user');
	$getlist->limit();
	%activeusers = $getlist->select();

	foreach($getlist->col_array()) {
		$activemembers{$activeusers{$_}{'user'}} = 1; # Keep user in memory for checking online status quickly
		push(@activeusers,"$activeusers{$_}{'user'}|$activeusers{$_}{'guest'}|$activeusers{$_}{'time'}|$activeusers{$_}{'view'}|$activeusers{$_}{'boardid'}|$activeusers{$_}{'messageid'}");
		++$totactive;
	}

	$delcache = 0;
	CoreLoad('settings',2);
	if(!$delcache) {
		$getlist = SQL->new('settings','variable');
		$getlist->limit();
		%settings = $getlist->select();
		$cache = Cache->new();
		$cache->hash('settings',%settings);
		$cache->save('settings',120);
	}

	if($totactive > $settings{'maxactive'}{'value'}) {
		$getlist = SQL->new('settings');

		if($settings{'maxactive'}{'value'} eq '') {
			$getlist->into('variable','value');

			$getlist->insert('maxactive',$totactive);
			$getlist->insert('maxactivetime',time);
		} else {
			$getlist->where('variable');
			$getlist->set('value');

			$getlist->update($totactive,'maxactive');
			$getlist->update(time,'maxactivetime');
		}

		Cache->delete('stats');
	}
}

sub error {
	$gdisable = 1;

	my($ecode,$elog,$notfound) = @_;
	my($ttime,$etype,$icon);
	if($ecode eq 'OPEN_ERROR'){ $ecode = $rtxt[56]; }
	$error = BC(Format($ecode));
	if($error =~ /-admin-/ || $error =~ /-register-/) { SpecialErrors(); }
	$icon = 'ban';
	if($elog && $elog < 3) {
		if($elog == 2) { $rtxt[18] = $rtxt[51]; $rtxt[19] = "<strong>$rtxt[51] $rtxt[41]:</strong> $rtxt[53]"; }
		$ewhat = "$rtxt[18] ";

		$esig = <<"EOT";
<tr>
 <td class="vtop center" style="width: 30px"><img src="$images/forbidden.png" alt="" /></td>
 <td>$rtxt[66]</td>
</tr>
EOT

		if($kelog) {
			chomp $!; chomp $error; chomp $errorurl;
			$errorurl = "Blah.pl?$ENV{'QUERY_STRING'}";
			$ttime = time;
			$specify = $! || '?';

			$sql = SQL->new('errorlog');
			$sql->into('message','extrainfo','time','userid','url');
			$sql->insert($error,$specify,$ttime,$username,$errorurl);
		}
	}
	$ewhat .= $rtxt[41];
	if($elog == 3) {
		$ewhat = $boardlock[33];
	}
	$error =~ s/$code|$prefs/./gsi;  # Security: Change full paths to local
	$error =~ s/\$rights/&lt;blah v="\$copyright"&gt;/g;
	if($root ne '.') { $error =~ s/$root/./gsi; }
	$title = $ewhat;
	$date_time = get_date(time,1);

	if($plinks ne '') {
		$plinks = <<"EOT";
<tr>
 <td class="catbg">$rtxt[32]</td>
</tr><tr>
 <td class="win links">$plinks</td>
</tr>
EOT
	}

	if($adminsloaded) { headerA(); } else { header(); }
	$ebout .= <<"EOT";
<table class="border" cellpadding="5" cellspacing="1" width="100%">
 <tr>
  <td class="titlebg">$title</td>
 </tr><tr>
  <td class="win3" style="padding: 10px">Sorry, but an error occurred. If you are unsure about how to solve this error you can contact the system administrator.</td>
 </tr><tr>
  <td class="win">
   <table cellpadding="5" cellspacing="0" width="100%">
    <tr>
     <td class="vtop center" style="width: 30px"><img src="$images/error.png" alt="" /></td>
     <td>$error</td>
    </tr>$esig
   </table>
  </td>
 </tr>$qlogin$plinks<tr>
  <td class="win2 smalltext right" style="padding: 8px;"><a href="mailto:$eadmin">$rtxt[50]</a></td>
 </tr>
</table>
EOT
	if($adminsloaded) { footerA(); } else { footer(); }
	exit;
}

sub redirect {
	($url2,$noexit) = $_[0];

	if($url eq '') { $url = $surl; }
	if($url2) { $url = $url2; }
	if($redirectfix == 1) { print qq~Content-type: text/html\n\n<html><head><meta http-equiv="refresh" content="0;URL=$url"></head></html>~; } 
	elsif($redirectfix == 2) { print "Refresh: 0;url=$url\n\n"; }
		else { print "Location: $url\n\n"; }
	if(!$noexit) { exit; }
}

sub get_date {
	my($date,$unbld,$personalized,$hourcnt) = @_;
	my($tdate);

	$date = time if($date eq '');

	if($personalized) { ($sec,$min,$hour,$day,$month,$year,$week,$ydays,$dst) = localtime($date); }
		else {
			if($date+10800 > time && !$unbld && $btod) {
				$tdate = int((time-$date)/60);
				if($tdate == 0) { return($rtxt[64]); }
				elsif($tdate == 1) { return($rtxt[63]); }
				elsif($tdate < 60 && $tdate > 0) { return("$tdate $rtxt[62]"); }
				elsif($tdate > 60 && $tdate < 120) { return($rtxt[68]); }
				elsif($tdate > 120 && $tdate < 360) { return(ceil($tdate/60)." $rtxt[69]"); }
			}

			($sec,$min,$hour,$day,$month,$year,$week,$ydays,$dst) = gmtime($date+(3600*($memberid{$username}{'timezone'}+$memberid{$username}{'dst'}+$gtoff)));
		}

	$curmonth = $month;
	$ampm = 'am';
	$year = 1900 + $year;
	if($min < 10) { $min = "0$min"; }
	if($hour == 12) { $ampm = 'pm'; }
	if($hour == 0) { $hour = 12; }
	if($hour > 12) {
		$hour -= 12;
		$ampm = 'pm';
	}
	if($sec < 10) { $sec = "0$sec"; }

	date_dis($unbld);
	return($ddis);
}

sub date_dis {
	my($blocknext,$REP);
	if($notime_date) { $ddis = "$months[$month] $day, $year"; $notime_date = ''; return(); }

	$ddis = '';
	for($REP = 0; $REP < length($DateDisplay); ++$REP) {
		$temp = substr($DateDisplay, $REP, 1);
		if($temp eq '\\') { $blocknext = 1; next; }
		if(!$blocknext) { $temp = TimeVariables($temp); }
		$ddis .= "$temp";
		$blocknext = 0;
	}
}

sub TimeVariables {
	my($tztemp);

	if($_[0] eq 'l') { return($days[$week]); }
	elsif($_[0] eq 'j') { return($day); }
	elsif($_[0] eq 'S') {
		if($day < 20 && $day > 10) { return('th'); }
		elsif($day % 10 == 1) { return('st'); }
		elsif($day % 10 == 2) { return('nd'); }
		elsif($day % 10 == 3) { return('rd'); }
			else { return('th'); }
	} elsif($_[0] eq 'D') { return($sdays[$week]); }
	elsif($_[0] eq 'd') {
		if($day < 10) { return("0$day"); } else { return($day); }
	} elsif($_[0] eq 'w') { return($week); }
	elsif($_[0] eq 'N') { return($week+1); }
	elsif($_[0] eq 'z') { return($ydays); }
	elsif($_[0] eq 'F') { return($months[$month]); }
	elsif($_[0] eq 'm') {
		if($month < 9) { return("0".($month+1)); } else { return($month+1); }
	}
	elsif($_[0] eq 'M') { return($smonths[$month]); }
	elsif($_[0] eq 'n') { return($month+1); }
	elsif($_[0] eq 'Y') { return($year); }
	elsif($_[0] eq 'y') { return(substr($year, 2)); }
	elsif($_[0] eq 'a') { return($ampm); }
	elsif($_[0] eq 'A') { return(uc($ampm)); }
	elsif($_[0] eq 'g') { return($hour); }
	elsif($_[0] eq 'G') {
		if($ampm eq 'pm' && $hour != 12) { return($hour+12); }
		elsif($hour == 12 && $ampm eq 'am') { return('0'); }
			else { return($hour); }
	}
	elsif($_[0] eq 'h') {
		if($hour < 10) { return("0$hour"); } else { return($hour); }
	}
	elsif($_[0] eq 'H') {
		if($ampm eq 'pm' && $hour != 12) { return($hour+12); }
		elsif($hour == 12 && $ampm eq 'am') { return('00'); }
			else {
				if($hour < 10) { return("0$hour"); } else { return($hour); }
			}
	}
	elsif($_[0] eq 'i') { return($min); }
	elsif($_[0] eq 's') { return($sec); }
		else { return($temp); }
}

sub ClickLog {
	my($clt,$lgtm,$rawprint,$clicklog);
	if($uextlog) { ++$ExtLog[0]; }

	return() if !$eclick;

	$ref = $ENV{'HTTP_REFERER'} =~ /$rurl/ ? '' : $ENV{'HTTP_REFERER'};
	$ref = Format($ref);

	$ref = '' if(length($ref) > 200);
	$ENV{'QUERY_STRING'} = '' if(length($ENV{'QUERY_STRING'}) > 200);
	$ENV{'HTTP_USER_AGENT'} = '' if(length($ENV{'HTTP_USER_AGENT'}) > 200);

	$clicklog = SQL->new('clicklog');
	$clicklog->where('time|<');
	$clicklog->delete(time-($logcnt*60));
	$clicklog->into('time','ipaddress','refer','query','agent');
	$clicklog->insert(time,$ENV{'REMOTE_ADDR'},$ref,$ENV{'QUERY_STRING'},$ENV{'HTTP_USER_AGENT'});
}

sub BCSmileys {
	my($tempsmile) = $_[0];

	my($smilecnt,$temper);
	if($simages2 ne '') { $temper = $simages; $simages = $simages2; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q::)\E~<img src="$simages/roll.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:)\E~<img src="$simages/smiley.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:-)\E~<img src="$simages/smiley.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:D\E~<img src="$simages/lol.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:-D\E~<img src="$simages/lol.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:B\E~<img src="$simages/blush.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q??)\E~<img src="$simages/huh.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:'(\E~<img src="$simages/cry.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:X\E~<img src="$simages/lipsx.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:o\E~<img src="$simages/shock.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:K)\E~<img src="$simages/kiss.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~(\A|\W);D~$1<img src="$simages/grin.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q;-D\E~<img src="$simages/grin.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q8)\E~<img src="$simages/cool.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:P\E~<img src="$simages/tongue.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q\&gt;:(\E~<img src="$simages/angry.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:-/\E~<img src="$simages/undecided.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:(\E~<img src="$simages/sad.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~\Q:-(\E~<img src="$simages/sad.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~(\A|\W)\Q;)\E~$1<img src="$simages/wink.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	while($smilecnt < $gmaxsmils && $tempsmile =~ s~(\A|\W)\Q;-)\E~$1<img src="$simages/wink.gif" style="vertical-align: middle" alt="" />~) { ++$smilecnt; }
	if($upbc) {
		if($temper ne '') { $simages = $temper };
		if(!$SmileysOpen) {
			CoreLoad('smilies',2);
			if(!$delcache) {
				$smiley = SQL->new('smileys','smiley');
				$smiley->limit();
				$smiley->columns('smiley','url');
				%Smiley = $smiley->select();
				@Smilies = $smiley->col_array();
				$smiley = Cache->new();
				$smiley->array('Smilies',@Smilies);
				$smiley->hash('Smiley',%Smiley);
				$smiley->save('smilies',1440);
			}
			$SmileysOpen = 1;
		}

		foreach(@Smilies) {
			$tempsmile =~ s~\Q$Smiley{$_}{'smiley'}\E~<img src="$simages/$Smiley{$_}{'url'}" style="vertical-align: middle" alt="" />~g;
		}
	}

	return($tempsmile);
}

sub Quote {
	my($qdate,$qmessage,$repaste,$qname);
	if($2) {
		GetMemberID($1);
		if($memberid{$1}{'sn'} ne '') { $qname = $userurl{$1}; }
			else { $qname = $1; }

		if($3) {
			$qdate = get_date($3);
			$quotedfrom = qq~$rtxt[22] <strong>$qname</strong>, $rtxt[23] <strong>$qdate</strong> $rtxt[21] <strong><a href="$2" title="$rtxt[25]">$rtxt[26]</a></strong>~;
			$qmessage = $4;
		} else { $quotedfrom = qq~$rtxt[22] <strong>$qname</strong>~; $qmessage = $2; }
	} else {
		$quotedfrom = "<strong>$rtxt[27]</strong>";
		$qmessage = $1;
	}

	return <<"EOT";
<blockquote>
 <div class="win3 quoteby">$quotedfrom</div>
 <div class="win quotebody">$qmessage</div>
</blockquote>
EOT
}

sub SizedURL {
	my $url;

	$url = $_[1];

	if(length($url) > 100 && $URL{'v'} ne 'print') { $url = substr($url,0,30).'.....'.substr($url,length($url)-20); }
	return(qq~$_[0]<a href="$_[1]"$blanktarget>$url</a>~);
}

sub Code {
	if($BCLoad == 0) { return; }

	%translation = (
		'('  => '&#040;',
		'D'  => '&#068;',
		')'  => '&#041;',
		'-'  => '&#045;',
		'/'  => '&#047;',
		':'  => '&#058;',
		'?'  => '&#063;',
		'['  => '&#091;',
		'\\' => '&#092;',
		']'  => '&#093;',
		'.'  => '&#046;'
	);
	$codelander = $1;

	$height = 50;
	$codelander =~ s/&nbsp; &nbsp; &nbsp;/\t/g; # DO THE TABS

	while($codelander =~ s/<br \/>/\n/s) { $height += 10; }
	$codelander =~ s/<br \/>/\n/g;

	$codelander =~ s/([\:\(\)\-\/\?\[\]\\\.D])/$translation{$1}/g;
	$height = 350 if($height > 350);

	return <<"EOT";
<table class="border" cellpadding="0" cellspacing="1">
 <tr>
  <td>
   <div class="win3" style="padding: 8px"><strong>$rtxt[57]</strong></div>
   <div class="win" style="padding: 2px; overflow: auto; width: 800px; height: $height\lpx; margin: 0px;">
    <table cellpadding="0" cellspacing="0" class="innertable">
     <tr>
      <td style="padding: 8px"><pre>$codelander</pre></td>
     </tr>
    </table>
   </div>
  </td>
 </tr>
</table>
EOT
}

sub BC {
	my($tempinput) = $_[0];
	my($temp1,$temp2,$ol);

	if($tempinput eq '') { return(); }

	$or_nosmiley = $or_nobc = $or_html = 0;
	while($tempinput =~ s/^\#(nosmiley|nobc|html)//) { ${"or_$1"} = 1; }

	if($html && $nosmile < 2 && !$or_html) {
		$tempinput =~ s/&quot;/"/g;
		if($htmls[0] ne '') {
			foreach(@htmls) {
				$close = $open = 0;
				while($tempinput =~ s~\&lt;$_(\w? || .*?)\&gt;~<$_$1$2>~) { ++$open; }
				while($tempinput =~ s~\&lt;/$_(.*?)\&gt;~</$_$1>~) { ++$close; }
				while($open > $close) { $tempinput .= "</$_>"; ++$close; } # Close open tags ('security')
			}
		} else { $tempinput =~ s~\&lt;(.*?)\&gt;~<$1>~gsi; }
	}
	$tempinput =~ s~\[code\](.+?)\[/code\]~Code()~esgi;

	while($tempinput =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\[/quote\]~Quote()~gsie) { }
	while($tempinput =~ s~\[quote=(.+?)\](.+?)\[/quote\]~Quote()~gsie) { }
	while($tempinput =~ s~\[quote\](.+?)\[/quote\]~Quote()~gsie) { }

	if($al) {
		$tempinput =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%,.]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,$2)~eisg;
		$tempinput =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A|[\<\n\b\>])\\*(www\.[^\.][\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%\,]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~SizedURL($1,"http://$2")~eisg;
	}
	if($BCSmile && ($nosmile != 1 && $nosmile != 3 && !$or_nosmiley)) { $tempinput = BCSmileys($tempinput); }

	if(!$BCLoad || $or_nobc) { return(CensorList($tempinput)); } # BC is disabled =(

	while($tempinput =~ s~\[s\](.*?)\[/s\]~<span style="text-decoration: line-through;">$1</span>~gsi) { }
	while($tempinput =~ s~\[b\](.+?)\[/b\]~<strong>$1</strong>~gsi) { }
	while($tempinput =~ s~\[i\](.*?)\[/i\]~<span style="font-style: italic;">$1</span>~gsi) { }
	while($tempinput =~ s~\[u\](.*?)\[/u\]~<span style="text-decoration: underline;">$1</span>~gsi) { }
	while($tempinput =~ s~\[blockquote\](.*?)\[/blockquote\]~<blockquote>$1</blockquote>~gsi) { }
	while($tempinput =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\[/size\]~<span style="font-size: $1px;">$2</span>~gsi) { }

	$tempinput =~ s~\[img\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$1://$2" alt="" />~gsi;
	$tempinput =~ s~\[img width=([1-9][^\s]*?) height=([1-9][^\s]*?)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$3://$4" width="$1" height="$2" alt="" />~gsi;
	$tempinput =~ s~\[img width=([1-9][^\s]*?) height=([1-9][^\s]*?) align=(right|left)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$4://$5" width="$1" height="$2" class="$3img" alt="" />~gsi;
	$tempinput =~ s~\[img align=(right|left)\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/img\]~<img src="$2://$3" class="$1img" alt="" />~gsi;

	$tempinput =~ s~\[url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="$1://$2" title="$2" onclick="target='_new';">$3</a>~gsi;
	$tempinput =~ s~\[url=www\.(.[^\s\n<>]+?)\](.+?)\[/url\]~<a href="http://www.$1" title="www.$1" onclick="target='_new';">$2</a>~gsi;
	$tempinput =~ s~\[url\](http|ftp|mms|https)://(.[^\s\n<>]+?)\[/url\]~SizedURL('',"$1://$2")~egsi;
	$tempinput =~ s~\[url\]www\.(.[^\s\n<>]+?)\[/url\]~SizedURL('',"http://www.$1")~egsi;

	$tempinput =~ s~\[youtube\]([A-Za-z0-9\_\+]+?)\[\/youtube\]~<object width="425" height="350"><param name="movie" value="http://www.youtube.com/v/$1"></param><embed src="http://www.youtube.com/v/$1" type="application/x-shockwave-flash" width="425" height="350"></embed></object>~gsi;
	$tempinput =~ s~\[tube\]http://www.youtube.com/(.[^\s\n<>]+?)\[\/tube\]~<object width="425" height="350"><param name="movie" value="http://www.youtube.com/$1"></param><embed src="http://www.youtube.com/$1" type="application/x-shockwave-flash" width="425" height="350"></embed></object>~gsi;

	$tempinput =~ s~\[flash width=([0-9]*?) height=([0-9]*?) url=(http|ftp|mms|https)://(.[^\s\n<>]+?)\]~<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="$1" height="$2"><param name="movie" value="$3://$4" /><param name="play" value="true" /><param name="loop" value="true" /><param name="quality" value="high" /><embed src="$3://$4" width="$1" height="$2" play="true" loop="true" quality="high"></embed></object>~gsi;

	$tempinput =~ s~\[pre\](.+?)\[/pre\]~<pre>$1</pre>~gsi;

	while($tempinput =~ s~^(.*?)\[list=?([a-zA-Z|1]*?)\](.*?)\[/list\](.*?)\Z~~s) {
		$tempinput = $1;
		$temp1 = $3; $temp2 = $4;

		$tempinput .= $2 ne '' ? qq~<ol type="$2">~ : '<ul>';
		$ol = $2 ne '' ? '</ol>' : '</ul>';

		$temp1 =~ s/^\<br \/\>//g;
		while($temp1 =~ s~\[\*\](.+?)(\[\*\]|\<li\>|\Z)~<li>$1</li>$2~gsi) { }

		$tempinput .= $temp1.$ol.$temp2;
	}

	while($tempinput =~ s~\[left\](.+?)\[/left\]~<div style="text-align: left">$1</div>~gsi) { }
	while($tempinput =~ s~\[right\](.+?)\[/right\]~<div style="text-align: right">$1</div>~gsi) { }
	while($tempinput =~ s~\[center\](.+?)\[/center\]~<div style="text-align: center">$1</div>~gsi) { }
	while($tempinput =~ s~\[justify\](.+?)\[/justify\]~<div style="text-align: justify">$1</div>~gsi) { }
	while($tempinput =~ s~\[face=(.+?)\](.+?)\[/face\]~<span style="font-family: $1">$2</span>~gsi) { }
	while($tempinput =~ s~\[color=(.+?)\](.+?)\[/color\]~<span style="color: $1">$2</span>~gsi) { }

	$tempinput =~ s~\[glow=(.+?) strength=(.+?)\](.*?)\[/glow\]~<span style="filter:glow(color=$1, strength=$2);height: 1px;">$3</span>~gsi;
	$tempinput =~ s~\[glow=(.+?)\](.*?)\[/glow\]~<span style="filter:glow(color=$1, strength=5);height: 1px;">$2</span>~gsi;
	$tempinput =~ s~\[shadow=(.+?) strength=(.+?)\](.*?)\[/shadow\]~<span style="filter:shadow(color=$1, strength=$2);height: 1px;">$3</span>~gsi;
	$tempinput =~ s~\[shadow=(.+?)\](.*?)\[/shadow\]~<span style="filter:shadow(color=$1, strength=5);height: 1px;">$2</span>~gsi;

	$tempinput =~ s~\[hr\]~<hr />~gsi;
	$tempinput =~ s~\[sub\](.+?)\[/sub\]~<sub>$1</sub>~gsi;
	$tempinput =~ s~\[sup\](.+?)\[/sup\]~<sup>$1</sup>~gsi;
	$tempinput =~ s~\[mail\](.+?)\[/mail\]~<a href="mailto:$1">$1</a>~gsi;
	$tempinput =~ s~\[mail=(.+?)\](.+?)\[/mail\]~<a href="mailto:$1">$2</a>~gsi;
	$tempinput =~ s~\[move\](.+?)\[/move\]~<marquee>$1</marquee>~gsi;

	if($tempinput =~ /\[table\](.+?)\[\/table\]/) {
		$tempinput =~ s/<br \/>/\t/gsi;
		while($tempinput =~ s~\t{0,1}\[table\]\t{0,1}(.+?)\t{0,1}\[\/table\]\t{0,1}~<table class="innertable">$1</table>~sgi) {
			while($tempinput =~ s~<table class="innertable">\t{0,1}(.*?)\t{0,1}\[tr\]\t{0,1}(.*?)\t{0,1}\[/tr\]\t{0,1}(.*?)\t{0,1}</table>~<table class="innertable">$1<tr>$2</tr>$3</table>~sgi) { } # Loop until rows are done.
			while($tempinput =~ s~<table class="innertable">(.*?)<tr>\t{0,1}(.*?)\t{0,1}\[td\]\t{0,1}(.*?)\t{0,1}\[/td\]\t{0,1}(.*?)\t{0,1}</tr>(.*?)</table>~<table class="innertable">$1<tr>$2<td>$3</td>$4</tr>$5</table>~sig) { } # Loop until cols are done.
		}
		$tempinput =~ s/\t/<br \/>/gsi;
	}
	return(CensorList($tempinput));
}

sub smail {
	my($subject,$message,$wholemessage,$tothis);
	my($to,$subject,$message,$from) = @_;
	if(!$to || !$subject || !$message) { return(-1); }
	if($to !~ /\A([0-9A-Za-z\._\-]{1,})@([0-9A-Za-z\._\-]{1,})+\.([0-9A-Za-z\._\-]{1,})+\Z/) { return(-1); }

	$message =~ s/\cM//g;
	$message =~ s/\n/<br \/>/gsi;
	$message =~ s/  /&nbsp; /gsi;
	$message =~ s/&lt;br&gt;/<br \/>/gsi;
	$message =~ s/<br \/>/<br \/>\n/gsi;
	$message =~ s/bgcolor="(.+?)"/bgcolor="#FFFFFF"/gsi;
	$emailsig = Unformat($emailsig);
	if($emailsig) { $message .= qq~<br /><br /><hr />$emailsig~; }

	$wholemessage = <<"EOT";
<html>
<body bgcolor="#FFFFFF">
<div style="font-family: Verdana, Arial; color: #000000; font-size: 12px;">$message</div>
</body>
</html>
EOT
	if($eadmin eq '') { $eadmin = "noreply\@noreply.noreply"; }
	if($mailuse == 1) {
		open(MAIL,"| $smaill -t");
		print MAIL "MIME-Version: 1.0\n";
		print MAIL "Content-Type: text/html; charset=\"ISO-8859-1\"\n";
		print MAIL "Content-Transfer-Encoding: 7bit\n";
		print MAIL "X-Forum-System: E-Blah, $version, copyright 2001-2006\n";
		print MAIL "X-Username: $username\n";
		print MAIL "X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n";
		print MAIL "To: $to\n";
		print MAIL "From: \"$regto\" <$eadmin>\n";
		print MAIL "Subject: $subject\n\n";
		print MAIL "$wholemessage";
		print MAIL "\n\n";
		close(MAIL);
	} elsif($mailuse == 2) {
		eval q{
			use Net::SMTP;
			my $smtp = Net::SMTP->new($mailhost);
			$smtp->auth($mailusername,$mailpassword) if($mailauth);
			$smtp->mail($eadmin);
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend("MIME-Version: 1.0\n");
			$smtp->datasend("Content-Type: text/html; charset=ISO-8859-1\n");
			$smtp->datasend("Content-Transfer-Encoding: 7bit\n");
			$smtp->datasend("X-Forum-System: E-Blah, $version, copyright 2001-2006\n");
			$smtp->datasend("X-Username: $username\n");
			$smtp->datasend("X-Sent-From-IP: $ENV{'REMOTE_ADDR'}\n");
			$smtp->datasend("To: $to\n");
			$smtp->datasend("From: \"$regto\" <$eadmin>\n");
			$smtp->datasend("Subject: $subject\n\n");
			$smtp->datasend("$wholemessage");
			$smtp->datasend("\n");
			$smtp->dataend();
			$smtp->quit;
		};
		if($@) { error("[b]Net::SMTP Error[/b]\n\n$@",2); }
	}

	$maildebug = 0; # Debugging is so lame ... but gotta do it to make stuff work!  =(
	if($maildebug) {
		$time = time;
		fopen(OPENFILE,">$root/$time\_mailed.txt");
		print OPENFILE "To: $to\nFrom: \"$from\" <$eadmin>\nSubject: $subject\n\n$wholemessage";
		fclose(OPENFILE);
	}

	return(1); # Clean return
}

sub ExtClose { # Save extensive log ..
	my($save,$u,$day,$month,$year);

	($t,$t,$t,$day,$month,$year) = localtime(time);
	$year += 1900;
	++$month;
	if($day < 10) { $day = "0$day"; }
	if($month < 10) { $month = "0$month"; }
	$save = $day.$month.$year;

	for($u = 0; $u < 9; $u++) {
		$ExtLog[$u] = 0 if($ExtLog[$u] eq '');
	}

	$sql = SQL->new('extlog');
	$sql->where('id');
	$sql->set("clicks|+$ExtLog[0]","threads|+$ExtLog[1]","replies|+$ExtLog[2]","members|+$ExtLog[3]","attachments|+$ExtLog[4]","downloads|+$ExtLog[5]",'time',"spammers|+$ExtLog[8]");
	$affected = $sql->update(time,$save);

	if($affected eq '0E0') {
		$sql->into('id','clicks','threads','replies','members','attachments','downloads','time','spammers');
		$sql->insert($save,$ExtLog[0],$ExtLog[1],$ExtLog[2],$ExtLog[3],$ExtLog[4],$ExtLog[5],time,$ExtLog[8]);
	}
}

sub Mark {
	my($sqlstate);
	if($username eq 'Guest') { error($gtxt{'noguest'}.'-register-'); }

	$time = time;

	$sqlstate = SQL->new('memberlog');

	$sqlstate->into('userid','board','visited');

	if($URL{'b'} ne '') {
		$sqlstate->where('userid','board||OR','board');
		$sqlstate->delete($username,"$URL{'b'}","AllRead_$URL{'b'}");
		$sqlstate->insert($username,"AllRead_$URL{'b'}",$time);
	} else {
		$sqlstate->where('userid');
		$sqlstate->delete($username);
		$sqlstate->insert($username,"AllBoards",$time);
	}

	redirect() if($URL{'v'} ne 'register');
}

sub MakeComma {
	$ctobe = $_[0];
	if(!$nocomma) { return($ctobe); }
	if(!$ctobe) { return(0); }
	while($ctobe =~ s/^([-+]?\d+)(\d{3})/$1$nocomma$2/) { } # Loop and make commas
	return($ctobe);
}

sub SpecialErrors {
	$error =~ s/(-admin-|-register-)//g;

	$plinks .= qq~<ul><li><a href="$surl\lv-register/" rel="nofollow">$rtxt[33]</a></li><li><a href="$surl\lv-login/" rel="nofollow">$rtxt[34]</a></li><li><a href="$surl\lv-login/p-forgotpw/" rel="nofollow">$rtxt[81]</a></li></ul>~;

	$qlogin = <<"EOT";
<tr>
 <td class="catbg">$rtxt[80]</td>
</tr><tr>
 <td class="win3">
  <form action="$surl\lv-login/p-2/" method="post">
   <table cellpadding="4" cellspacing="0" class="innertable" width="300">
    <tr>
     <td>$rtxt[36]</td>
    </tr><tr>
	 <td><input type="text" name="username" size="20" tabindex="56" /></td>
    </tr><tr>
     <td>$rtxt[37]</td>
    </tr><tr>
     <td><input type="password" name="password" size="20" tabindex="57" /></td>
    </tr><tr>
     <td><input type="hidden" name="days" value="forever" /><input type="hidden" name="redirect" value="$ENV{'QUERY_STRING'}" /><input type="submit" value="&nbsp;&nbsp;$rtxt[38]&nbsp;&nbsp;" tabindex="58" /></td>
    </tr>
   </table>
  </form>
 </td>
</tr>
EOT
}

sub ShowGuest {
	CoreLoad('Login',1);

	$guestlogin = <<"EOT";
<table cellpadding="4" cellspacing="1" class="border" width="450">
 <tr>
  <td class="titlebg smalltext"><strong>$rtxt[35]</strong></td>
 </tr><tr>
  <td class="win">
   <form action="$surl\lv-login/p-2/" method="post">
    <table cellpadding="2" cellspacing="0" width="100%">
     <tr>
      <td class="smalltext"><strong>$rtxt[36]:</strong></td>
      <td colspan="2"><input type="text" name="username" size="20" tabindex="56" /></td>
      <td class="smalltext"><strong><a href="$surl\lv-register/" rel="nofollow">$logintxt[3]</a></strong></td>
     </tr><tr>
      <td class="smalltext"><strong>$rtxt[37]:</strong></td>
      <td><input type="password" name="password" size="20" tabindex="57" /></td>
      <td>&nbsp; &nbsp;<input type="hidden" name="days" value="forever" /><input type="hidden" name="redirect" value="$ENV{'QUERY_STRING'}" /><input type="submit" value="&nbsp;&nbsp;$rtxt[38]&nbsp;&nbsp;" tabindex="58" /></td>
      <td class="smalltext"><strong><a href="$surl\lv-login/p-forgotpw/" rel="nofollow">$logintxt[5]</a></strong></td>
     </tr>
    </table>
   </form>
  </td>
 </tr>
</table><br />
EOT
}

sub calage {
	($bday) = @_;
	($t,$t,$t,$td,$tm,$ty) = localtime(time);
	($m,$d,$y) = split("/",$bday);
	$ty += 1900;
	if($y < 1900) { $y += 1900; }
	$age = ($ty-$y)-1;
	if((($tm+1) == $m && $td >= $d) || ($tm+1) > $m) { ++$age; }
	if(!$bday) { $age = 0; } else { --$m; $ageurl = "$surl\lv-cal/month-".($m+1)."/"; }
	return($age);
}

sub Highlight {
	$_[0] =~ s/<br \/>/<br \/>\n/gsi;
	@smallm = split(/(<.*?>)\s/,$_[0]);
	$_[0] = '';

	foreach(@smallm) {
		if($_ !~ /[ht|f]tp/ && $_ !~ /<(.*?)>/) {
			foreach $hl (@lights) {
				if($hl eq '') { next; }
				$_ =~ s~(\Q$hl\E)~<span style="background-color:yellow; color: black; font-weight: bold;">$1</span>~isg;
			}
		}
		$_[0] .= "$_ ";
	}
}

sub VerifyBoard { # This simply verifies that the user requesting, has authorization to get the data requested
	my($id,$nme,$grps,$input,$memgrp,$catbase,@binfo,$grp);

	foreach $catbase (@catbase) {
		next if(!GetMemberAccess($cats{$catbase}{'permissions'}));

		$catallow{$catbase} = 1;
		++$catcounter;
	}

	foreach $boardindex (@boardbase) {
		next if(!$catallow{$boards{$boardindex}{'parent'}});
		next if(!GetMemberAccess($boards{$boardindex}{'access_perm'}));

		$boardallow{$boardindex} = 1;

		$readallow{$boardindex} = GetMemberAccess($boards{$boardindex}{'read_perm'});
		++$boardcounter;
	} # Command outputs: $[cat|board]allow{id} and $[cat|board]counter
}

sub SetCookie { # Gets cookie data, and prints it
	my($cookname,$cookvalue,$cookexp) = @_;
	print "Set-Cookie: $cookname=$cookvalue; path=/; expires=$cookexp\n";
	return();
}

sub CheckTime {
	print "Content-type: text/html\n\n";
	$URL{'zone'} =~ s/\'/\-/g;
	$memberid{$username}{'timezone'} = $URL{'zone'};
	$memberid{$username}{'dst'} = 1 if($URL{'saving'} eq 'true');
	$memberid{$username}{'dst'} = 0 if($URL{'saving'} eq 'false');

	if($datedisplayH{$URL{'date'}} ne '') { $DateDisplay = $datedisplayH{$URL{'date'}}; }
		else { $DateDisplay = $FORM{'date'}; }
	$DateDisplay = $DateDisplay.$timedisplayH{$URL{'time'}};
	print get_date(time,1);
	print qq~<div style="margin-top: 5px"><strong>$rtxt[70]:</strong> $DateDisplay</div>~;
	exit;
}

sub GetActiveUsers { # Outputs: $hidec, $botc, $memcnt, $gcnt, $memberson, $B{x}, $useronline{y}
	my($luser,$ltime,$lview,$lboard,$lmess,@quicksort,$coloruser,$isguest);

	foreach(@activeusers) {
		chomp $_;
		($luser,$isguest) = split(/\|/,$_);
		GetMemberID($luser) if(!$isguest);
		$tuser = $memberid{$luser}{'sn'} || $botsearch{$luser} || $luser;
		push(@quicksort,"$tuser|$_");
	}

	$activecnt = @quicksort;

	$hidec = $botc = $memcnt = $gcnt = 0;

	foreach(sort{lc($a) cmp lc($b)} @quicksort) {
		($t,$luser,$t,$ltime,$lview,$lboard,$lmess) = split(/\|/,$_);
		++$B{$lboard};

		if($URL{'b'} ne '' && $URL{'b'} ne $lboard) { next; }

		$t = get_date($ltime);

		if($memberid{$luser}{'sn'} ne '') {
			$coloruser = $permissions{$membergrp{$luser}}{'color'} ? qq~ class="usercolors" style="color: $permissions{$membergrp{$luser}}{'color'}"~ : '';

			if($memberid{$luser}{'hideonline'}) {
				++$hidec;
				if($members{'Administrator',$username}) { $memberson .= qq~<i><a href="$surl\lv-memberpanel/a-view/u-$luser/" rel="nofollow"$coloruser title="$t">$memberid{$luser}{'sn'}</a></i>, ~; }
					else { next; }
			} else {
				++$memcnt;
				$memberson .= qq~<a href="$surl\lv-memberpanel/a-view/u-$luser/" rel="nofollow"$coloruser title="$t">$memberid{$luser}{'sn'}</a>, ~;
			}

			$useronline{$luser} = 1;
		} elsif($botsearch{$luser}) {
			$memberson .= qq~<a title="$t" class="onlinebots" style="cursor:default;">$botsearch{$luser}</a>, ~;
			++$botc;
		} else { ++$gcnt; }
	}

	$memberson =~ s/, \Z//i;
	if($memberson eq '') { $memberson = $ltxt[20]; }
}

sub ceil {
	return int($_[0] + .5 * ($_[0] <=> 0));
}

sub PageLinks {
	my($pages,$numperpage,$turl,$small,$extraurl) = @_;
	my($pagelinks);
	$URL{'s'} = 0 if($small ne '');

	$treplies = $pages < 0 ? 1 : $pages;
	if($treplies <= $numperpage) {
		return() if($small ne '');
		$pagelinks = "<strong>1</strong>";
		$totalpages = 1;
		$URL{'s'} = 0;
	} else {
		$totalpages = int(($treplies/$numperpage)+.99);

		$tstart = $URL{'s'} || 0;
		$counter = 1;
		$link = "$surl\l$extraurl";
		$link .= "$turl-$URL{$turl}" if($turl ne '' && $URL{$turl} ne '');
		$link =~ s/\/\Z//g;
		if($tstart > $treplies) { $tstart = $treplies; }
		$tstart = (int($tstart/$numperpage)*$numperpage);
		if($tstart > 0) { $bk = ($tstart-$numperpage); $pagelinks = qq~<a href="$link/s-$bk/">&#171;</a> ~; }
		if($treplies > ($tmax/2) && $tstart > $numperpage*($startdot+1) && $treplies > $tmax) { $pagelinks .= qq~<a href="$link/">...</a> ~; }
		for($i = 0; $i < $treplies+1; $i += $numperpage) {
			if($i < $bk-($numperpage*$startdot) && $treplies > $tmax) { ++$counter; $final = $counter-1; next; }
			if($small eq '' && ($i == $tstart || $treplies < $numperpage)) {
				$pagelinks .= $small eq '' ? "<strong>$counter</strong> " : $counter.', ';
				$nxt = ($tstart+$numperpage);
			}
				else {
					my $s = "s-$i/" if($i > 0);
					$pagelinks .= $small eq '' ? qq~<a href="$link/$s">$counter</a> ~ :  qq~<a href="$link/$s">$counter</a>, ~;
				}
			++$counter;
			if($counter > $totalpp+$final && $treplies > $tmax) { $gbk = (int($treplies/$numperpage)*$numperpage); $pagelinks .= qq~ <a href="$link/s-$gbk/">...</a> ~; ++$i; last; }
		}
		if(($tstart+$numperpage) != $i) { $pagelinks .= qq~ <a href="$link/s-$nxt/">&#187;</a>~ if($small eq ''); }
	}
	$pagelinks =~ s/, \Z//g if($small ne '');

	return($pagelinks,$tstart);
}

sub GetMassUsers { # This will query a lot of users at once to limit queries
	my(@massusers) = @_;
	my(@auwhere,@aufind);

	foreach(@massusers) {
		next if($_ eq $username || $sqlmemberloaded{$_} || $_ eq '' || $_ !~ s~^(\.?\d+\.?\d*)\Z~$1~g);
		push(@auwhere,"userid||OR");
		push(@aufind,$_);
		$sqlmemberloaded{$_} = 1;
	}

	if($aufind[0] eq '') { return(); }

	$sql = SQL->new('members','userid');
	$sql->limit();
	$sql->where(@auwhere);
	%memberid = (%memberid,$sql->select(@aufind));
}

sub Shownews {
	my($shownewstemp,@news,$filetype,$counter);
	($save,$filetype) = @_;
	if($filetype eq '') {
		if($URL{'a'} eq 'headlines' || $URL{'a'} eq 'feed') { $filetype = 'xml'; }
			else { $filetype = 'html'; }
	}

	if($filetype eq 'xml') {
		if(!$save) { print "Content-type: text/xml\n\n"; }
		if($URL{'b'} eq '') { $title = $mbname; }
			else { $title = $boardnm; }

		$shownewstemp .= <<"EOT";
<?xml version="1.0" encoding="$char"?>
<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">
 <channel>
  <title>$title</title>
  <link>$rurl</link>
  <generator>http://www.eblah.com</generator>
  <description></description>
  <language>en</language>
EOT
	} else { print "Content-type: text/html\n\n" if !$save; }

	if($URL{'b'} ne '' && $URL{'v'} eq 'shownews' && GetMemberAccess($boards{$URL{'b'}}{'read_perm'})) { $newsboard = $URL{'b'}; }
		elsif($URL{'c'} && $URL{'v'} eq 'shownews') {
			$newsboard = '';
			foreach(@catbase) {
				($t,$boardid) = split(/\|/,$_);
				$catbase{$boardid} = $_;
			}

			foreach(@boardbase) {
				($id) = split("/",$_);
				$board{$id} = $_;
			}

			($name,$boardid,$memgroups,$boardlist,$message,$subcats) = split(/\|/,$catbase{$URL{'c'}});
			if(GetMemberAccess($memgroups)) {
				foreach $bid (split("/",$boardlist)) {
					($t,$t,$t,$t,$t,$t,$t,$t,$t,$t,$binfo[9]) = split("/",$board{$bid});
					if(!GetMemberAccess($binfo[9])) { next; }
					$newsboard .= "$bid,";
				}
				GetSubCats($subcats);
			}
		}

	@open = split(",",$newsboard);
	foreach $openbrd (@open) {
		push(@where,"boardid||AND||(","moveid|NULL|OR|||)");
		push(@whereeq,"$openbrd");
	}

	if(@where > 0) {
		$sql = SQL->new('topics','id');
		$sql->where(@where);
		$sql->limit(0,$newsshow);
		$sql->order('creationtime|DESC');
		$sql->columns('startuser','id','creationtime','subject','icon','replies');
		%topics = $sql->select(@whereeq);
		@topics = $sql->col_array();
	}

	foreach(@topics) {
		$sql2 = SQL->new('posts','threadid');
		$sql2->columns('smiley','message','threadid');
		$sql2->where('threadid');
		$sql2->order('posttime|ASC');
		%messages = (%messages,$sql2->select($_));
	}

	$counter = 0;

	$newslength = $newslength || 2000;

	fopen(FILE,"$templates/News.html");
	@temp = <FILE>;
	fclose(FILE);
	chomp @temp;

	foreach $messid (@topics) {
		$message = $messages{$messid}{'message'};
		$posted = $topics{$messid}{'startuser'};
		$nosmiley = $messages{$messid}{'smiley'};
		$time = $topics{$messid}{'creationtime'};
		$messtitle = $topics{$messid}{'subject'};
		$micon = $topics{$messid}{'icon'};
		$replies = $topics{$messid}{'replies'};
		$sdate = get_date($time,1);

		GetMemberID($posted);
		if($memberid{$posted}{'sn'} eq '') { $userpost = $posted; }
			else { $userpost = $userurl{$posted}; }
		$totalurl = "$rurl\lm-$messid/";

		if($filetype eq 'xml') {
			$message = BC($message);

			if($memberid{$posted}{'sn'} eq '') { $userpost = $posted; }
				else { $userpost = $memberid{$posted}{'sn'}; }

			($s,$m,$h,$day,$month,$year,$wday) = localtime($time);
			$year += 1900;
			++$month;
			if($h < 10) { $h = "0$h"; }
			if($m < 10) { $m = "0$m"; }
			if($s < 10) { $s = "0$s"; }

			$shownewstemp .= <<"EOT";
  <item>
   <title>$messtitle</title>
   <link>$totalurl</link>
   <comments>$totalurl#num1</comments>
   <description><![CDATA[$message]]></description>
   <pubDate>$sdays[$wday], $day $smonths[$month-1] $year $h:$m:$s</pubDate>
   <dc:creator>$userpost</dc:creator>
  </item>
EOT
		} else {
			if(length($message) > $newslength) {
				$message =~ s~\[table\](.*?)\[\/table\]~$var{'88'}~sgi;
				$message = substr($message,0,$newslength);

				$message =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+://[\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%,.]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]\Z)~~eisg;
				$message =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A|[\<\n\b\>])\\*(www\.[^\.][\w\~\.\;\:\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%\,]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]\Z)~~eisg;

				$message = BC($message);
				MakeSmall();
				$message .= qq~<br /><br /><a href="$rurl\lm-$messid/">$portal[48]</a>~;
			} else { $message = BC($message); }
			foreach(@temp) {
				$pdata = $_;
				$pdata =~ s/<blah v="\$(.+?)">/${$1}/gsi;
				$shownewstemp .= "$pdata\n";
			}
		}

		++$counter;
	}
	if($filetype eq 'xml') { $shownewstemp .= " </channel>\n</rss>"; }
	print $shownewstemp if !$save;
	if($save) {
		fopen(FILE,">$templates/Shownews.$filetype");
		print FILE $shownewstemp;
		fclose(FILE);
	}
	exit if !$save;
}
1;